{*_* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

Author:       Franois PIETTE
Description:  Trivial sample program for TIcsSocket !
Creation:     April 29, 2001
Version:      1.00.2 BETA
EMail:        http://www.overbyte.be       francois.piette@overbyte.be
              http://www.rtfm.be/fpiette   francois.piette@rtfm.be
Support:      This code is unsupported.
Legal issues: Copyright (C) 2000-2001 by Franois PIETTE
              Rue de Grady 24, 4053 Embourg, Belgium. Fax: +32-4-365.74.56
              <francois.piette@overbyte.be>

              This software is provided 'as-is', without any express or
              implied warranty.  In no event will the author be held liable
              for any  damages arising from the use of this software.

              Permission is granted to anyone to use this software for any
              purpose, including commercial applications, and to alter it
              and redistribute it freely, subject to the following
              restrictions:

              1. The origin of this software must not be misrepresented,
                 you must not claim that you wrote the original software.
                 If you use this software in a product, an acknowledgment
                 in the product documentation would be appreciated but is
                 not required.

              2. Altered source versions must be plainly marked as such, and
                 must not be misrepresented as being the original software.

              3. This notice may not be removed or altered from any source
                 distribution.

              4. You must register this software by sending a picture postcard
                 to the author. Use a nice stamp and mention your name, street
                 address, EMail address and any comment you like to say.

History:
Apr 29, 2001 V1.00 Initial release

 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
unit Cli1;

interface

uses
  SysUtils, Types, Classes, Variants, QGraphics, QControls, QForms, QDialogs,
  IcsSocket, QStdCtrls, QExtCtrls;

type
  TForm1 = class(TForm)
    IcsSocket1: TIcsSocket;
    Panel1: TPanel;
    ConnectButton: TButton;
    DisplayMemo: TMemo;
    DisconnectButton: TButton;
    DataEdit: TEdit;
    SendButton: TButton;
    procedure ConnectButtonClick(Sender: TObject);
    procedure IcsSocket1SessionConnected(Sender: TObject; Error: Word);
    procedure DisconnectButtonClick(Sender: TObject);
    procedure IcsSocket1DataAvailable(Sender: TObject; Error: Word);
    procedure SendButtonClick(Sender: TObject);
  private
    { Private declarations }
    procedure Display(const Text : String);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.xfm}


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TForm1.ConnectButtonClick(Sender: TObject);
begin
    IcsSocket1.Port             := '23';
    IcsSocket1.Addr             := '10.161.63.1';
    IcsSocket1.LineMode         := TRUE;
    IcsSocket1.ComponentOptions := [isoSyncEvents];
    IcsSocket1.Connect;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TForm1.Display(const Text : String);
begin
    DisplayMemo.Lines.Add(Text);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TForm1.IcsSocket1SessionConnected(Sender: TObject; Error: Word);
begin
    Display('Connected');
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TForm1.DisconnectButtonClick(Sender: TObject);
begin
    IcsSocket1.Close;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TForm1.IcsSocket1DataAvailable(Sender: TObject; Error: Word);
var
    Line : String;
begin
    Line := IcsSocket1.ReceiveStr;
    Display(Line);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TForm1.SendButtonClick(Sender: TObject);
begin
    if IcsSocket1.State <> wsConnected then
        Display('*** Not connected ***')
    else
        IcsSocket1.SendStr(DataEdit.Text + #13#10);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}

end.
