{*_* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

Author:       Franois PIETTE
Description:  TIcsSocket class encapsulate the Socket paradigm for Windows and
              for Linux. This code compiles with Delphi 5 and Kylix FT3.
              THIS IS BETA CODE TESTED WITH KYLIX FIELD TEST 3 (FT3).
              IT CONTAINS A LOT OF BUGS USE IT WITH CAUTIONS.
              You can upgrade to the release version short after Kylix has been
              released to the public.
Creation:     Augustus 14, 2000
Version:      1.00.2 BETA
EMail:        http://www.overbyte.be       francois.piette@overbyte.be
              http://www.rtfm.be/fpiette   francois.piette@rtfm.be
Support:      This code is unsupported.
Legal issues: Copyright (C) 2000-2001 by Franois PIETTE
              Rue de Grady 24, 4053 Embourg, Belgium. Fax: +32-4-365.74.56
              <francois.piette@overbyte.be>

              This software is provided 'as-is', without any express or
              implied warranty.  In no event will the author be held liable
              for any  damages arising from the use of this software.

              Permission is granted to anyone to use this software for any
              purpose, including commercial applications, and to alter it
              and redistribute it freely, subject to the following
              restrictions:

              1. The origin of this software must not be misrepresented,
                 you must not claim that you wrote the original software.
                 If you use this software in a product, an acknowledgment
                 in the product documentation would be appreciated but is
                 not required.

              2. Altered source versions must be plainly marked as such, and
                 must not be misrepresented as being the original software.

              3. This notice may not be removed or altered from any source
                 distribution.

              4. You must register this software by sending a picture postcard
                 to the author. Use a nice stamp and mention your name, street
                 address, EMail address and any comment you like to say.

History:
Feb 26, 2001 V1.00.1 Checked with Kylix V1.0 Build 5.38
Apr 29, 2001 V1.00.2 Use retail Desktop Developer Build 5.62
                     Removed use or errno which doesn't exists anymore

 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
unit IcsSocket;

{$J+}

interface

uses
{$IFDEF WIN32}
  Windows, Messages, Graphics, Controls, Forms, Dialogs, WinSock,
{$ELSE}
    libc,
{$ENDIF}
  SysUtils, Classes, IcsSockBuf, SyncObjs;

const
  IcsSocketVersion          = 100;
  CopyRight    : String     = ' TIcsSocket (c) 2001 F. Piette V1.00 ';
{$IFDEF LINUX}
    FIONREAD	        = $541B;
    FIONBIO	        = $5421;
    WSAEINTR            = EINTR;
    WSAEBADF            = EBADF;
    WSAEACCES           = EACCES;
    WSAEFAULT           = EFAULT;
    WSAEINVAL           = EINVAL;
    WSAEMFILE           = EMFILE;
    WSAEWOULDBLOCK      = EWOULDBLOCK;
    WSAEINPROGRESS      = EINPROGRESS;
    WSAEALREADY         = EALREADY;
    WSAENOTSOCK         = ENOTSOCK;
    WSAEDESTADDRREQ     = EDESTADDRREQ;
    WSAEMSGSIZE         = EMSGSIZE;
    WSAEPROTOTYPE       = EPROTOTYPE;
    WSAENOPROTOOPT      = ENOPROTOOPT;
    WSAEPROTONOSUPPORT  = EPROTONOSUPPORT;
    WSAESOCKTNOSUPPORT  = ESOCKTNOSUPPORT;
    WSAEOPNOTSUPP       = EOPNOTSUPP;
    WSAEPFNOSUPPORT     = EPFNOSUPPORT;
    WSAEAFNOSUPPORT     = EAFNOSUPPORT;
    WSAEADDRINUSE       = EADDRINUSE;
    WSAEADDRNOTAVAIL    = EADDRNOTAVAIL;
    WSAENETDOWN         = ENETDOWN;
    WSAENETUNREACH      = ENETUNREACH;
    WSAENETRESET        = ENETRESET;
    WSAECONNABORTED     = ECONNABORTED;
    WSAECONNRESET       = ECONNRESET;
    WSAENOBUFS          = ENOBUFS;
    WSAEISCONN          = EISCONN;
    WSAENOTCONN         = ENOTCONN;
    WSAESHUTDOWN        = ESHUTDOWN;
    WSAETOOMANYREFS     = ETOOMANYREFS;
    WSAETIMEDOUT        = ETIMEDOUT;
    WSAECONNREFUSED     = ECONNREFUSED;
    WSAELOOP            = ELOOP;
    WSAENAMETOOLONG     = ENAMETOOLONG;
    WSAEHOSTDOWN        = EHOSTDOWN;
    WSAEHOSTUNREACH     = EHOSTUNREACH;
    WSAENOTEMPTY        = ENOTEMPTY;
    WSAEPROCLIM         = 999990;
    WSAEUSERS           = EUSERS;
    WSAEDQUOT           = EDQUOT;
    WSAESTALE           = ESTALE;
    WSAEREMOTE          = EREMOTE;
    WSASYSNOTREADY      = 999991;
    WSAVERNOTSUPPORTED  = 999992;
    WSANOTINITIALISED   = 999993;
    WSAHOST_NOT_FOUND   = 999994;
    WSATRY_AGAIN        = 999995;
    WSANO_RECOVERY      = 999996;
    WSANO_DATA          = 999997;
{$ENDIF}
    icsSocksNoError              = 20000;
    icsSocksProtocolError        = 20001;
    icsSocksVersionError         = 20002;
    icsSocksAuthMethodError      = 20003;
    icsSocksGeneralFailure       = 20004;
    icsSocksConnectionNotAllowed = 20005;
    icsSocksNetworkUnreachable   = 20006;
    icsSocksHostUnreachable      = 20007;
    icsSocksConnectionRefused    = 20008;
    icsSocksTtlExpired           = 20009;
    icsSocksUnknownCommand       = 20010;
    icsSocksUnknownAddressType   = 20011;
    icsSocksUnassignedError      = 20012;
    icsSocksInternalError        = 20013;
    icsSocksDataReceiveError     = 20014;
    icsSocksAuthenticationFailed = 20015;
    icsSocksRejectedOrFailed     = 20016;
    icsSocksHostResolutionFailed = 20017;

type
  ESocketException      = class(Exception);
  TBgExceptionEvent     = procedure (Sender : TObject;
                                     E : Exception;
                                     var CanClose : Boolean) of object;
  TIcsSocketState       = (wsInvalidState,
                           wsOpened,     wsBound,
                           wsConnecting, wsConnected,
                           wsListening,  wsClosed);
  TIcsSocketSendFlags   = (wsSendNormal, wsSendUrgent);
  TIcsSocketLingerOnOff = (wsLingerOff, wsLingerOn, wsLingerNoSet);
{$IFDEF WIN32}
  TSockAddr             = Winsock.TSockAddr;
  socklen_t             = Integer;
{$ELSE}
  TSockAddrIn           = sockaddr;
  Tlinger               = linger;
{$ENDIF}

  TIcsSocksAuthentication = (icsSocksNoAuthentication, icsSocksAuthenticateUsercode);
  TIcsSocksAuthState      = (icsSocksAuthStart, icsSocksAuthSuccess, icsSocksAuthFailure, icsSocksAuthNotRequired);
  TIcsSocksAuthStateEvent = procedure(Sender : TObject; AuthState : TIcsSocksAuthState) of object;
  TIcsSocksErrorEvent     = procedure(Sender : TObject; Error : Integer; Msg : String) of Object;
  TIcsProcOfObject        = procedure of object;
  TIcsNotifyEvent         = procedure (Sender: TObject; Error: word) of object;
  TIcsSendData            = procedure (Sender: TObject; BytesSent: Integer) of object;
  TIcsChangeState         = procedure (Sender: TObject;
                                       OldState : TIcsSocketState;
                                       NewState : TIcsSocketState) of object;
  TIcsDebugDisplay        = procedure (Sender: TObject; var Msg : String) of object;
  TIcsSocketOption        = (isoNoReceiveLoop, isoSyncEvents);
  TIcsSocketOptions       = set of TIcsSocketOption;
  PSocket                 = ^TSocket;

  TIcsWorkerThreadOperation = (iwtNoop, iwtGetHostByName, iwtConnect, iwtRead,
                               iwtListen, iwtAccept, iwtDup, iwtSocksConnect);

  PIcsThread = ^TIcsThread;
  TIcsThread = class(TThread)
  protected
      FPID                 : Integer;
      FName                : String;
      FHSocketLocation     : PSocket;
      FOldState            : TIcsSocketState;
      FState               : TIcsSocketState;
      FSyncEvents          : Boolean;
      FEventObject         : TEvent;
      FLastError           : LongInt;
      FinishedFlag         : Boolean;
      ClosedByRemote       : Boolean;
      ClosedByRemoteError  : Integer;
      ComponentState       : TComponentState;
      FOnClose             : TIcsProcOfObject;
      FOnChangeState       : TIcsProcOfObject;
      procedure SynchronizeMethod(Proc : TIcsProcOfObject);
      procedure SetHSocket(aSocket : TSocket);
      function  GetHSocket : TSocket;
      procedure DoTerminate; override;
      procedure ChangeState(NewState: TIcsSocketState);
      procedure TriggerChangeState;
  public
      constructor Create(CreateSuspended : Boolean); virtual;
      destructor  Destroy; override;
      procedure   SetEvent;
      procedure   WaitEvent;
      property ReadEvent         : TEvent            read  FEventObject;
      property LastError         : LongInt           read  FLastError;
      property State             : TIcsSocketState   read  FState
                                                     write FState;
      property OldState          : TIcsSocketState   read  FOldState;
      property Name              : String            read  FName
                                                     write FName;
      property SyncEvents        : Boolean           read  FSyncEvents
                                                     write FSyncEvents;
      property HSocket           : TSocket           read  GetHSocket
                                                     write SetHSocket;
      property HSocketLocation   : PSocket           read  FHSocketLocation
                                                     write FHSocketLocation;
      property OnClose           : TIcsProcOfObject  read  FOnClose
                                                     write FOnClose;
      property OnChangeState     : TIcsProcOfObject  read  FOnChangeState
                                                     write FOnChangeState;
  end;

  TIcsWorkerThread = class(TIcsThread)
  protected
      Fsin                 : TSockAddrIn;
      FASocketLocation     : PSocket;
      FOperation           : TIcsWorkerThreadOperation;
      FParamString         : String;
      FResultInAddr        : TInAddr;
      FProtoStr            : String;
      FProtoResolved       : Boolean;
      FProto               : integer;
      FType                : integer;
      FPortStr             : String;
      FPortResolved        : Boolean;
      FPortNum             : integer;
      FLocalPortStr        : String;
      FLocalPortNum        : integer;
      FLocalPortResolved   : Boolean;
      FSocksError          : Integer;
      FSocksErrorMsg       : String;
      FAddrStr             : String;
      FAddrResolved        : Boolean;
      FLocalAddr           : String;     { IP address for local interface to use }
      FSocksServer         : String;
      FSocksLevel          : String;
      FSocksPort           : String;
      FSocksUsercode       : String;
      FSocksPassword       : String;
      FSocksAuthentication : TIcsSocksAuthentication;
      FSocksAuthNumber     : char;
      FSocksAuthState      : TIcsSocksAuthState;
      FSocksBoundAddr      : String;
      FSocksBoundPort      : String;
      FDnsResultList       : TStrings;
      FLingerOnOff         : TIcsSocketLingerOnOff;
      FLingerTimeout       : Integer;              { In seconds, 0 = disabled }
      FCloseDelayedFlag    : Boolean;
      Error                : Integer;
      FOnOperationDone     : TIcsProcOfObject;
      FOnDoReadReady       : TIcsProcOfObject;
      FOnSocketExcept      : TIcsProcOfObject;
      FOnSocksConnected    : TIcsProcOfObject;
      FOnSocksAuthState    : TIcsProcOfObject;
      FOnSocksError        : TIcsProcOfObject;
      procedure OpGetHostByName;
      procedure OpConnect;
      procedure OpSocksConnect;
      procedure OpCommonConnect;
      procedure OpListenStart;
      procedure OpAccept;
      procedure OpDup;
      procedure OpRead;
      function  SetNonBlocking : Boolean;
      procedure SocksSessionConnected;
      procedure SocksDoConnect;
      procedure SocksDoAuthenticate;
      procedure SocksConnectedToRemote;
      procedure SocksAuthenticateReply;
      procedure TriggerSocksError(ErrCode : Integer; Msg : String);
      procedure BindSocket;
      procedure SetLingerOption;
      procedure SetASocket(xSocket : TSocket);
      function  GetASocket : TSocket;
      procedure SetAddrStr(NewValue : String);
      procedure SetPortStr(NewValue : String);
      procedure SetProtoStr(NewValue : String);
  public
      constructor Create(CreateSuspended : Boolean); override;
      procedure Execute; override;
      procedure SocketClose;
      property HSocket           : TSocket           read  GetHSocket
                                                     write SetHSocket;
      property ASocket           : TSocket           read  GetASocket
                                                     write SetASocket;
      property Operation : TIcsWorkerThreadOperation read  FOperation
                                                     write FOperation;
      property CloseDelayedFlag    : Boolean         read  FCloseDelayedFlag
                                                     write FCloseDelayedFlag;
      property ParamString : String                  read  FParamString
                                                     write FParamString;
      property ResultInAddr : TInAddr                read  FResultInAddr
                                                     write FResultInAddr;
      property DnsResultList   : TStrings            read  FDnsResultList
                                                     write FDnsResultList;
      property ProtoStr        : String              read  FProtoStr
                                                     write SetProtoStr;
      property PortStr         : String              read  FPortStr
                                                     write SetPortStr;
      property LocalPortStr    : String              read  FLocalPortStr
                                                     write FLocalPortStr;
      property LocalAddr       : String              read  FLocalAddr
                                                     write FLocalAddr;
      property AddrStr         : String              read  FAddrStr
                                                     write SetAddrStr;
      property LingerOnOff     : TIcsSocketLingerOnOff
                                                     read  FLingerOnOff
                                                     write FLingerOnOff;
      property LingerTimeout   : Integer             read  FLingerTimeout
                                                     write FLingerTimeout;
      property HSocketLocation : PSocket             read  FHSocketLocation
                                                     write FHSocketLocation;
      property ASocketLocation : PSocket             read  FASocketLocation
                                                     write FASocketLocation;
      property SocksServer       : String            read  FSocksServer
                                                     write FSocksServer;
      property SocksLevel        : String            read  FSocksLevel
                                                     write FSocksLevel;
      property SocksPort         : String            read  FSocksPort
                                                     write FSocksPort;
      property SocksUsercode     : String            read  FSocksUsercode
                                                     write FSocksUsercode;
      property SocksPassword     : String            read  FSocksPassword
                                                     write FSocksPassword;
      property SocksAuthentication : TIcsSocksAuthentication
                                                     read  FSocksAuthentication
                                                     write FSocksAuthentication;
      property SocksAuthState      : TIcsSocksAuthState
                                                     read  FSocksAuthState
                                                     write FSocksAuthState;
      property OnOperationDone   : TIcsProcOfObject  read  FOnOperationDone
                                                     write FOnOperationDone;
      property OnDoReadReady     : TIcsProcOfObject  read  FOnDoReadReady
                                                     write FOnDoReadReady;
      property OnSocketExcept    : TIcsProcOfObject  read  FOnSocketExcept
                                                     write FOnSocketExcept;
  end;

  TIcsWriterThread = class(TIcsThread)
  private
      FOnWriteReady      : TIcsProcOfObject;
  public
      constructor Create(CreateSuspended : Boolean); override;
      procedure   Execute; override;
      property OnWriteReady      : TIcsProcOfObject  read  FOnWriteReady
                                                     write FOnWriteReady;
  end;

  TCustomIcsSocket = class(TComponent)
  private
    sin                 : TSockAddrIn;
    FBufList            : TList;
    FBufSize            : Integer;
    FBufCritSect        : TCriticalSection;
    FHSocket            : TSocket;
    FASocket            : TSocket;
    FAddrStr            : String;
    FAddrResolved       : Boolean;
    FAddrFormat         : Integer;
    FAddrAssigned       : Boolean;
    FProto              : integer;
    FProtoAssigned      : Boolean;
    FProtoResolved      : Boolean;
    FLocalPortResolved  : Boolean;
    FProtoStr           : String;
    FPortStr            : String;
    FPortAssigned       : Boolean;
    FPortResolved       : Boolean;
    FPortNum            : Integer;
    FLocalPortStr       : String;
//  FLocalPortNum       : Integer;
    FLocalAddr          : String;     { IP address for local interface to use }
    FType               : integer;
    bWrite              : Boolean;
    nMoreCnt            : Integer;
    bMoreFlag           : Boolean;
    nMoreMax            : Integer;
    bAllSent            : Boolean;
    FMultiThreaded      : Boolean;
    FLingerOnOff        : TIcsSocketLingerOnOff;
    FLingerTimeout      : Integer;              { In seconds, 0 = disabled }
    FCloseInvoked       : Boolean;
    FRcvdFlag           : Boolean;
    FSendDataCount      : Integer;
    FWorkerThread       : TIcsWorkerThread;
    FWriterThread       : TIcsWriterThread;
    FOnSessionAvailable : TIcsNotifyEvent;
    FOnSessionConnected : TIcsNotifyEvent;
    FOnSessionClosed    : TIcsNotifyEvent;
    FOnChangeState      : TIcsChangeState;
    FOnDataAvailable    : TIcsNotifyEvent;
    FOnDataSent         : TIcsNotifyEvent;
    FOnSendData         : TIcsSendData;
    FOnLineTooLong      : TNotifyEvent;
    FOnDnsLookupDone    : TIcsNotifyEvent;
    FOnError            : TNotifyEvent;
    FOnBgException      : TBgExceptionEvent;
    FOnDisplay          : TIcsDebugDisplay;
    FLastError          : Integer;
    FFlushTimeOut       : Integer;
    FSendFlags          : Integer;
    FReadCount          : LongInt;
    FDnsResult          : String;
    FDnsResultList      : TStrings;
    FComponentOptions   : TIcsSocketOptions;
    procedure   SocketError(SockFunc: String);
    procedure   SetSendFlags(newValue : TIcsSocketSendFlags);
    function    GetSendFlags : TIcsSocketSendFlags;
    procedure   SetAddr(InAddr : String);
    function    GetAddr : String;
    procedure   SetRemotePort(sPort : String); virtual;
    function    GetRemotePort : String;
    procedure   SetLocalAddr(sLocalAddr : String);
    procedure   SetLocalPort(sLocalPort : String);
    procedure   SetProto(sProto : String); virtual;
    function    GetProto : String;
    function    GetRcvdCount : LongInt; virtual;
    function    GetState : TIcsSocketState;
    function    GetWorkerThread : Boolean;
    function    GetWriterThread : Boolean;
//  procedure   RaiseExceptionFmt(const Fmt : String; args : array of const); virtual;
    procedure   RaiseException(const Msg : String); virtual;
//  procedure   TriggerDisplay(Msg : String);
    procedure   TriggerSendData(BytesSent : Integer);
    function    TriggerDataAvailable(Error : Word) : Boolean; virtual;
    procedure   TriggerSessionAvailable(Error : Word); virtual;
    procedure   TriggerSessionConnected(Error : Word); virtual;
    procedure   TriggerSessionClosed(Error : Word); virtual;
    procedure   TriggerChangeState(OldState, NewState : TIcsSocketState); virtual;
    procedure   TriggerDNSLookupDone(Error : Word); virtual;
    procedure   TriggerError; virtual;
    function  RealSend(Data : Pointer; Len : Integer) : Integer;
    procedure TryToSend;
    procedure SendText(const Value: String);
    procedure AssignDefaultValue; virtual;
    procedure DeleteBufferedData;
    procedure OperationDoneDnsLookup;
    procedure OperationDoneConnect;
    procedure OperationDoneListen;
    function  DoRecv(var Buffer; BufferSize, Flags: Integer): Integer; virtual;
    procedure SocketHasClosed;
    procedure ChangeState;
    procedure ReadReady;
    procedure DoReadReady; virtual;
    procedure DataSent;
    procedure DoDataSent; virtual;
    procedure CallSendData;
    procedure ShutdownThread(Thread : TIcsThread);
    procedure WaitForThread(PThread : PIcsThread);
    procedure KillWorkerAndWriterThreads;
  public
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;
    procedure   Connect; virtual;
    procedure   Close; virtual;
    procedure   CloseDelayed; virtual;
    procedure   Release; virtual;
    procedure   Abort; virtual;
    procedure   Flush; virtual;
    procedure   WaitForClose; virtual;
    procedure   Listen; virtual;
    function    Accept: TSocket; virtual;
    function    Receive(Buffer : Pointer; BufferSize: integer) : integer; virtual;
    function    ReceiveStr : string; virtual;
    function    ReceiveFrom(Buffer      : Pointer;
                            BufferSize  : Integer;
                            var From    : TSockAddr;
                            var FromLen : Integer) : integer; virtual;
    function    PeekData(Buffer : Pointer; BufferSize: integer) : integer;
    function    Send(Data : Pointer; Len : Integer) : integer; virtual;
    function    SendTo(Dest    : TSockAddr;
                       DestLen : Integer;
                       Data    : Pointer;
                       Len     : Integer) : integer; virtual;
    function    SendStr(const Str : String) : Integer; virtual;
    procedure   DnsLookup(HostName : String); virtual;
    procedure   ReverseDnsLookup(HostAddr: String); virtual;
    procedure   CancelDnsLookup; virtual;
    procedure   PutStringInSendBuffer(Str : String);
    procedure   PutDataInSendBuffer(Data : Pointer; Len : Integer);
    function    GetPeerAddr: string; virtual;
    function    GetPeerPort: string; virtual;
    function    GetPeerName(var Name : TSockAddrIn; NameLen : Integer) : integer; virtual;
    function    GetXPort: string; virtual;
    function    TimerIsSet(var tvp : TTimeVal) : Boolean; virtual;
    procedure   TimerClear(var tvp : TTimeVal); virtual;
    function    TimerCmp(var tvp : TTimeVal; var uvp : TTimeVal; IsEqual : Boolean) : Boolean; virtual;
    function    GetSockName(var saddr : TSockAddrIn; var saddrlen : Integer) : integer; virtual;
    procedure   SetLingerOption;
    procedure   Dup(NewHSocket : TSocket); virtual;
    procedure   Shutdown(How : Integer); virtual;
  protected
    property PortNum : Integer                      read  FPortNum;
    property HSocket : TSocket                      read  FHSocket
                                                    write Dup;

    property Addr : string                          read  GetAddr
                                                    write SetAddr;
    property Port : string                          read  GetRemotePort
                                                    write SetRemotePort;
    property LocalPort : String                     read  FLocalPortStr
                                                    write SetLocalPort;
    property LocalAddr : String                     read  FLocalAddr
                                                    write SetLocalAddr;
    property Proto : String                         read  GetProto
                                                    write SetProto;
    property PeerAddr : String                      read  GetPeerAddr;
    property PeerPort : String                      read  GetPeerPort;
    property DnsResult : String                     read  FDnsResult;
    property DnsResultList : TStrings               read  FDnsResultList;
    property State : TIcsSocketState                read  GetState;
    property AllSent   : Boolean                    read  bAllSent;
    property ReadCount : LongInt                    read  FReadCount;
    property RcvdCount : LongInt                    read  GetRcvdCount;
    property LastError : Integer                    read  FLastError;
    property MultiThreaded      : Boolean           read  FMultiThreaded
                                                    write FMultiThreaded;
    property ComponentOptions : TIcsSocketOptions   read  FComponentOptions
                                                    write FComponentOptions;
    property BufSize   : Integer                    read  FBufSize
                                                    write FBufSize;
    property OnDataAvailable : TIcsNotifyEvent      read  FOnDataAvailable
                                                    write FOnDataAvailable;
    property OnDataSent      : TIcsNotifyEvent      read  FOnDataSent
                                                    write FOnDataSent;
    property OnSendData      : TIcsSendData         read  FOnSendData
                                                    write FOnSendData;
    property OnSessionClosed : TIcsNotifyEvent      read  FOnSessionClosed
                                                    write FOnSessionClosed;
    property OnSessionAvailable : TIcsNotifyEvent   read  FOnSessionAvailable
                                                    write FOnSessionAvailable;
    property OnSessionConnected : TIcsNotifyEvent   read  FOnSessionConnected
                                                    write FOnSessionConnected;
    property OnChangeState      : TIcsChangeState   read  FOnChangeState
                                                    write FOnChangeState;
    property OnLineTooLong      : TNotifyEvent      read  FOnLineTooLong
                                                    write FOnLineTooLong;
    property OnDnsLookupDone    : TIcsNotifyEvent   read  FOnDnsLookupDone
                                                    write FOnDnsLookupDone;
    property OnError            : TNotifyEvent      read  FOnError
                                                    write FOnError;
    property OnBgException      : TBgExceptionEvent read  FOnBgException
                                                    write FOnBgException;

    property FlushTimeout : Integer                 read  FFlushTimeOut
                                                    write FFlushTimeout;
    property SendFlags : TIcsSocketSendFlags        read  GetSendFlags
                                                    write SetSendFlags;
    property Text: String                           read  ReceiveStr
                                                    write SendText;
    property LingerOnOff   : TIcsSocketLingerOnOff  read  FLingerOnOff
                                                    write FLingerOnOff;
    property LingerTimeout : Integer                read  FLingerTimeout
                                                    write FLingerTimeout;
    property OnDisplay : TIcsDebugDisplay           read  FOnDisplay
                                                    write FOnDisplay;
  end;

  TCustomSocksIcsSocket = class(TCustomIcsSocket)
  protected
      FSocksServer         : String;
      FSocksLevel          : String;
      FSocksPort           : String;
      FSocksPortAssigned   : Boolean;
      FSocksServerAssigned : Boolean;
      FSocksUsercode       : String;
      FSocksPassword       : String;
      FSocksAuthentication : TIcsSocksAuthentication;
      FBoundAddr           : String;
      FBoundPort           : String;
      FRcvBuf              : array [0..127] of char;
      FRcvCnt              : Integer;
      FSocksRcvdCnt        : Integer;
      FSocksRcvdPtr        : PChar;
      FOnSocksError        : TIcsSocksErrorEvent;
      FOnSocksConnected    : TIcsNotifyEvent;
      FOnSocksAuthState    : TIcsSocksAuthStateEvent;
      procedure   AssignDefaultValue; override;
//      procedure   TriggerSessionConnected(Error : Word); override;
      procedure   TriggerSocksConnected(Error : Word); virtual;
//      procedure   TriggerSessionClosed(Error : Word); override;
//      function    TriggerDataAvailable(Error : Word) : Boolean; override;
      procedure   SetSocksPort(sPort : String); virtual;
      procedure   SetSocksServer(sServer : String); virtual;
      procedure   TriggerSocksError(Error : Integer; Msg : String); virtual;
      procedure   TriggerSocksAuthState(AuthState : TIcsSocksAuthState);
//      function    GetRcvdCount : LongInt; override;
      procedure   SetSocksLevel(newValue : String);
//      function    DoRecv(var Buffer;
//                         BufferSize : Integer;
//                         Flags      : Integer) : Integer; override;
  public
      procedure   Connect; override;
//      procedure   Listen; override;
  protected
      property SocksServer   : String               read  FSocksServer
                                                    write SetSocksServer;
      property SocksLevel    : String               read  FSocksLevel
                                                    write SetSocksLevel;
      property SocksPort     : String               read  FSocksPort
                                                    write SetSocksPort;
      property SocksUsercode : String               read  FSocksUsercode
                                                    write FSocksUsercode;
      property SocksPassword : String               read  FSocksPassword
                                                    write FSocksPassword;
      property SocksAuthentication : TIcsSocksAuthentication
                                                    read  FSocksAuthentication
                                                    write FSocksAuthentication;
      property OnSocksError  : TIcsSocksErrorEvent  read  FOnSocksError
                                                    write FOnSocksError;
      property OnSocksConnected : TIcsNotifyEvent   read  FOnSocksConnected
                                                    write FOnSocksConnected;
      property OnSocksAuthState : TIcsSocksAuthStateEvent
                                                    read  FOnSocksAuthState
                                                    write FOnSocksAuthState;
  end;

  TCustomLineIcsSocket = class (TCustomSocksIcsSocket)
  protected
      FRcvdPtr             : PChar;
      FRcvBufSize          : Integer;
      FRcvdCnt             : Integer;
      FLineEnd             : String;
      FLineMode            : Boolean;
      FLineLength          : Integer;    { When a line is available }
      FLineReceivedFlag    : Boolean;
      FLineEcho            : Boolean;    { Echo received data    }
      FLineEdit            : Boolean;    { Edit received data    }
      FTimeout             : LongInt;    { Given in milliseconds }
      FTimeStop            : LongInt;    { Milliseconds          }
//      function    TriggerDataAvailable(Error : Word) : Boolean; override;
//      procedure   TriggerSessionClosed(Error : Word); override;
      procedure   SetLineMode(newValue : Boolean); virtual;
      procedure   EditLine(var Len : Integer); virtual;
      function    GetRcvdCount : LongInt; override;
      procedure   DoReadReady; override;
      function    DoRecv(var Buffer;
                         BufferSize : Integer;
                         Flags      : Integer) : Integer; override;
  public
      constructor Create(AOwner: TComponent); override;
      destructor  Destroy; override;
      property    LineLength : Integer     read  FLineLength;
  published
      property LineMode : Boolean          read  FLineMode
                                           write SetLineMode;
      property LineEnd  : String           read  FLineEnd
                                           write FLineEnd;
      property LineEcho : Boolean          read  FLineEcho
                                           write FLineEcho;
      property LineEdit : Boolean          read  FLineEdit
                                           write FLineEdit;
  end;

  TIcsSocket = class(TCustomLineIcsSocket)
  public
    property PortNum;
    property HSocket;
    property BufSize;
    property Text;
    property AllSent;
    property OnDisplay;
    property RcvdCount;
    property DnsResult;
    property DnsResultList;
    property PeerPort;
    property PeerAddr;
    property ReadCount;
    property State;
    property LastError;
    property MultiThreaded;
    property FlushTimeout;
  published
    property Addr;
    property Port;
    property Proto;
    property LocalAddr;
    property LocalPort;
    property ComponentOptions;
    property OnDataAvailable;
    property OnDataSent;
    property OnSendData;
    property OnSessionClosed;
    property OnSessionAvailable;
    property OnSessionConnected;
    property OnSocksConnected;
    property OnChangeState;
    property OnLineTooLong;
    property OnDnsLookupDone;
    property OnError;
    property OnBgException;
    property SendFlags;
    property LingerOnOff;
    property LingerTimeout;
    property SocksLevel;
    property SocksServer;
    property SocksPort;
    property SocksUsercode;
    property SocksPassword;
    property SocksAuthentication;
    property OnSocksError;
    property OnSocksAuthState;
    property LineMode;
    property LineEnd;
    property LineEcho;
    property LineEdit;
  end;

// Direct socket function calls remapped to local function to allow easy
// runtime dynamic link to DLL or SO
function Ics_sendto(s: TSocket; var Buf; len, flags: Integer;
                    var addrto: TSockAddr; tolen: Integer): Integer;
function Ics_send(s: TSocket; var Buf; len, flags: Integer): Integer;
function Ics_recv(s: TSocket; var Buf; len, flags: Integer): Integer;
function Ics_shutdown(s: TSocket; how: Integer): Integer;
function Ics_closesocket(s: TSocket): Integer;
function Ics_accept(s: TSocket; var addr: TSockAddr; var addrlen: Integer): TSocket;
function Ics_ntohs(netshort: u_short): u_short;
function Ics_socket(af, Struct, protocol: Integer): TSocket;
function Ics_ioctlsocket(s: TSocket; cmd: u_long; var arg: u_long): Integer;
function Ics_inet_ntoa(inaddr: TInAddr): PChar;
function Ics_bind(s: TSocket; var addr: TSockAddr; namelen: Integer): Integer;
function Ics_connect(s: TSocket; var name: TSockAddr; namelen: Integer): Integer;
function Ics_listen(s: TSocket; backlog: Integer): Integer;
function Ics_getsockname(s: TSocket; var name: TSockAddr; var namelen: Integer): Integer;
function Ics_setsockopt(s: TSocket; level, optname: Integer; optval: PChar; optlen: Integer): Integer;
function Ics_inet_addr(cp: PChar): u_long;
function Ics_getservbyname(name, proto: PChar): PServEnt;
function Ics_gethostbyname(name: PChar): PHostEnt;
function Ics_getprotobyname(name: PChar): PProtoEnt;
function Ics_getpeername(s: TSocket; var name: TSockAddr; var namelen: Integer): Integer;
function Ics_htons(hostshort: u_short): u_short;
{$IFDEF WIN32}
function Ics_WSAStartup(wVersionRequired: word; var WSData: TWSAData): Integer;
function Ics_WSACleanup: Integer;
{$ENDIF}

function IcsSocketErrorDesc(error: integer) : String;
procedure Register;

const
    IcsSocketDisplayFlag : Boolean = TRUE;
    IcsDisplayProc       : procedure (const Msg : String) = nil;

{$IFNDEF WIN32}
function ioctlsocket(__fd: Tsocket; cmd: u_long; var arg: u_long): Integer; cdecl;
function getpeername(__fd: TSocket; var __addr: sockaddr; var __len: socklen_t): Integer; cdecl;
{$ENDIF}

implementation

function IcsSocketResolveHost(InAddr : String) : TInAddr; forward;
function IcsSocketResolvePort(Port : String; Proto : String) : Word; forward;
function IcsSocketResolveProto(sProto : String) : Integer; forward;

{$IFDEF WIN32}
var
    GInitData      : TWSADATA;
//  IPList         : TStrings;
{$ENDIF}


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function ThreadIdToStr(ID : Integer) : String;
begin
{$IFDEF WIN32}
    Result := IntToHex(ID, 8);
{$ELSE}
    Result := IntToStr(ID);
{$ENDIF}
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  * * * * * * * *}
procedure IcsSocketDisplay(const S : String);
begin
    if IcsSocketDisplayFlag and Assigned(IcsDisplayProc) then
        IcsDisplayProc(S);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure Register;
begin
    RegisterComponents('ICS', [TIcsSocket]);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function Ics_sendto(
    s: TSocket; var Buf; len, flags: Integer;
    var addrto: TSockAddr; tolen: Integer): Integer;
begin
    Result := {$IFDEF WIN32} winsock.sendto {$ELSE} libc.sendto {$ENDIF}
    (s, Buf, len, flags, addrto, tolen);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function Ics_send(s: TSocket; var Buf; len, flags: Integer): Integer;
begin
    Result := {$IFDEF WIN32} winsock.send {$ELSE} libc.send {$ENDIF}
              (s, Buf, len, flags);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function Ics_recv(s: TSocket; var Buf; len, flags: Integer): Integer;
begin
    Result := {$IFDEF WIN32} winsock.recv {$ELSE} libc.recv {$ENDIF}
              (s, Buf, len, flags);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function Ics_shutdown(s: TSocket; how: Integer): Integer;
begin
    Result := {$IFDEF WIN32} winsock.shutdown {$ELSE} libc.shutdown {$ENDIF}
              (s, how);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function Ics_closesocket(s: TSocket): Integer;
begin
    Result := {$IFDEF WIN32} winsock.closesocket {$ELSE} libc.__close {$ENDIF} (s);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function Ics_accept(s: TSocket; var addr: TSockAddr; var addrlen: Integer): TSocket;
begin
    Result := {$IFDEF WIN32} winsock.accept(s, @addr, @addrlen);
              {$ELSE}        libc.accept(s, @addr, @addrlen); {$ENDIF}
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function Ics_ntohs(netshort: u_short): u_short;
begin
    Result := ntohs(netshort);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function Ics_socket(af, Struct, protocol: Integer): TSocket;
begin
    Result := socket(af, Struct, protocol);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function Ics_ioctlsocket(s: TSocket; cmd: u_long; var arg: u_long): Integer;
begin
{$IFDEF WIN32}
    Result := ioctlsocket(s, DWORD(cmd), arg);
{$ELSE}
    Result := ioctlsocket(s, cmd, arg);
{$ENDIF}
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function Ics_inet_ntoa(inaddr: TInAddr): PChar;
begin
    Result := inet_ntoa(inaddr);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function Ics_bind(s: TSocket; var addr: TSockAddr; namelen: Integer): Integer;
begin
    Result := bind(s, addr, namelen);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function Ics_connect(s: TSocket; var name: TSockAddr; namelen: Integer): Integer;
begin
    Result := connect(s, name, namelen);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function Ics_listen(s: TSocket; backlog: Integer): Integer;
begin
    Result := listen(s, backlog);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function Ics_setsockopt(s: TSocket; level, optname: Integer; optval: PChar; optlen: Integer): Integer;
begin
    Result := setsockopt(s, level, optname, optval, optlen);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function Ics_getsockname(s: TSocket; var name: TSockAddr; var namelen: Integer): Integer;
begin
    Result := {$IFDEF WIN32} winsock.getsockname(s, name, namelen);
              {$ELSE} libc.getsockname(s, name, socklen_t(namelen));{$ENDIF}

end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function Ics_inet_addr(cp: PChar): u_long;
begin
    Result := inet_addr(cp);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function Ics_getservbyname(name, proto: PChar): PServEnt;
begin
    Result := getservbyname(name, proto);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function Ics_gethostbyname(name: PChar): PHostEnt;
begin
    Result := gethostbyname(name);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function Ics_getprotobyname(name: PChar): PProtoEnt;
begin
    Result := getprotobyname(name);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function Ics_getpeername(
    s: TSocket; var name: TSockAddr; var namelen: Integer): Integer;
begin
    Result := getpeername(s, name, socklen_t(namelen));
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function Ics_htons(hostshort: u_short): u_short;
begin
    Result := htons(hostshort);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
{$IFDEF WIN32}
function Ics_WSAStartup(wVersionRequired: word; var WSData: TWSAData): Integer;
begin
    Result := WSAStartup(wVersionRequired, WSData);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function Ics_WSACleanup: Integer;
begin
    Result := WSACleanup;
end;
{$ENDIF}


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
{$IFNDEF WIN32}
function WSAGetLastError : Integer;
begin
    Result := GetLastError;
end;
{$ENDIF}


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure GetIPList(phe : PHostEnt; ToList : TStrings);
type
    TaPInAddr = array [0..255] of PInAddr;
    PaPInAddr = ^TaPInAddr;
var
    pptr : PaPInAddr; 
    I    : Integer;
begin
    pptr := PaPInAddr(Phe^.h_addr_list);

    I := 0;
    while pptr^[I] <> nil do begin
        ToList.Add(StrPas(Ics_inet_ntoa(pptr^[I]^)));
        Inc(I);
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.DeleteBufferedData;
var
    nItem : Integer;
begin
    FBufCritSect.Enter;
    try
        { Delete all data buffer }
        for nItem := 0 to FBufList.Count - 1 do
            TIcsBuffer(FBufList.Items[nItem]).Free;
        FBufList.Clear;
    finally
       FBufCritSect.Leave;
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function TCustomIcsSocket.GetState : TIcsSocketState;
begin
    if not Assigned(FWorkerThread) then
        Result := wsClosed
    else
        Result := FWorkerThread.State;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.Abort;
begin

end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function TCustomIcsSocket.Accept: TSocket;
begin
    if State <> wsListening then begin
        FLastError := WSAEINVAL;
        SocketError('not a listening socket');
        Result := INVALID_SOCKET;
        Exit;
    end;
    Result := FASocket;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  * * * * * * * *}
procedure IcsWorkerThreadSignalHandler(SigNum : Integer); cdecl;
begin
    IcsSocketDisplay('IcsSocket: Hello from IcsWorkerThreadSignalHandler ' +
                     '[PID=' + ThreadIdToStr(
{$IFDEF WIN32}
                                        Integer(GetCurrentThreadID)
{$ELSE}
                                        getpid
{$ENDIF}
                     ) + ']');
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  * * * * * * * *}
procedure TIcsWorkerThread.SetASocket(xSocket : TSocket);
begin
    if FASocketLocation <> nil then
        FASocketLocation^ := xSocket
    else
        raise Exception.Create('TIcsWorkerThread.ASocketLocation not set');
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  * * * * * * * *}
function  TIcsWorkerThread.GetASocket : TSocket;
begin
    if FASocketLocation <> nil then
        Result := FASocketLocation^
    else
        Result := INVALID_SOCKET;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  * * * * * * * *}
procedure TIcsWorkerThread.BindSocket;
var
    SockName      : TSockAddr;
    SockNamelen   : Integer;
    LocalSockName : TSockAddrIn;
begin
    FillChar(LocalSockName, Sizeof(LocalSockName), 0);
    SockNamelen                   := sizeof(LocalSockName);
    LocalSockName.sin_family      := AF_INET;
    LocalSockName.sin_port        := Ics_htons(FLocalPortNum);
    LocalSockName.sin_addr.S_addr := IcsSocketResolveHost(FLocalAddr).S_addr;

    if Ics_bind(HSocket, LocalSockName, SockNamelen) <> 0 then begin
        raise Exception.CreateFmt('bind failed, error #%d', [WSAGetLastError]);
        Exit;
    end;
    SockNamelen := sizeof(SockName);
    if Ics_getsockname(HSocket, SockName, SockNamelen) <> 0 then begin
        raise Exception.CreateFmt('getsockname failed, error #%d',
                          [WSAGetLastError]);
        Exit;
    end;
    FLocalPortNum := Ics_ntohs(SockName.sin_port);
    FLocalPortStr := IntToStr(FLocalPortNum);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.CancelDnsLookup;
begin

end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.Close;
var
    OldState : TIcsSocketState;
begin
IcsSocketDisplay(Name + ': Close');
    if Assigned(FWorkerThread) then begin
        if State <> wsClosed then begin
            OldState := State;
            FWorkerThread.SocketClose;
{$IFNDEF WIN32}
            IcsSocketDisplay(Name + ': kill(' + IntToStr(FWorkerThread.FPID) +
                             ', SIGUSR1)');
            kill(FWorkerThread.FPID, SIGUSR1);
{$ENDIF}
            KillWorkerAndWriterThreads;
            TriggerChangeState(OldState, wsClosed);
            TriggerSessionClosed(0);
        end;
    end;
IcsSocketDisplay(Name + ': Close done');
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.CloseDelayed;
begin
    if Assigned(FWorkerThread) then begin
        FWorkerThread.CloseDelayedFlag := TRUE;
        FWorkerThread.Resume;
        Ics_CloseSocket(FHSocket);
        FHSocket := INVALID_SOCKET;
{$IFNDEF WIN32}
        IcsSocketDisplay(Name + ': kill(' + IntToStr(FWorkerThread.FPID) +
                         ', SIGUSR1)');
        kill(FWorkerThread.FPID, SIGUSR1);
{$ENDIF}
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function TCustomIcsSocket.GetWorkerThread : Boolean;
begin
    Result := TRUE;
    { Create worker thread if needed, check if busy if already exists }
    if not Assigned(FWorkerThread) then begin
        FWorkerThread      := TIcsWorkerThread.Create(TRUE);
        FWorkerThread.Name := 'WorkerThread' + Name;
        FWorkerThread.FSyncEvents    := (isoSyncEvents in FComponentOptions);
        FWorkerThread.ComponentState := [];
    end
    else if FWorkerThread.Terminated then begin
        FWorkerThread.Destroy;
        FWorkerThread      := TIcsWorkerThread.Create(TRUE);
        FWorkerThread.Name := 'WorkerThread' + Name;
        FWorkerThread.FSyncEvents    := (isoSyncEvents in FComponentOptions);
        FWorkerThread.ComponentState := [];
    end
    else if not FWorkerThread.Suspended then
        Result := FALSE;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function TCustomIcsSocket.GetWriterThread : Boolean;
begin
    Result := TRUE;
    { Create writer thread if needed, check if busy if already exists }
    if not Assigned(FWriterThread) then begin
        FWriterThread      := TIcsWriterThread.Create(TRUE);
        FWriterThread.Name := 'WriterThread' + Name;
        FWriterThread.FSyncEvents    := (isoSyncEvents in FComponentOptions);
        FWriterThread.ComponentState := [];
    end
    else if FWriterThread.Terminated then begin
        FWriterThread.Destroy;
        FWriterThread      := TIcsWriterThread.Create(TRUE);
        FWriterThread.Name := 'WriterThread' + Name;
        FWriterThread.FSyncEvents    := (isoSyncEvents in FComponentOptions);
        FWriterThread.ComponentState := [];
    end
    else if not FWriterThread.Suspended then
        Result := FALSE;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.Connect;
begin
    if (FHSocket <> INVALID_SOCKET) and (State <> wsClosed) then begin
        RaiseException('Connect: Socket already in use');
        Exit;
    end;

    if  not FPortAssigned then begin
        RaiseException('Connect: No Port Specified');
        Exit;
    end;

    if not FAddrAssigned then begin
        RaiseException('Connect: No IP Address Specified');
        Exit;
    end;

    if not FProtoAssigned then begin
        RaiseException('Connect: No Protocol Specified');
        Exit;
    end;

    if not GetWorkerThread then begin
        RaiseException('Connect: Component is busy.');
        TriggerSessionConnected(WSAEINPROGRESS);
        Exit;
    end;

    { Remove any data from the internal output buffer }
    { (should already be empty !)                     }
    DeleteBufferedData;

    FWorkerThread.State := wsConnecting;
    ChangeState;
    FWorkerThread.HSocketLocation := @FHSocket;
    FWorkerThread.Operation       := iwtConnect;
    FWorkerThread.ProtoStr        := FProtoStr;
    FWorkerThread.PortStr         := FPortStr;
    FWorkerThread.LocalPortStr    := FLocalPortStr;
    FWorkerThread.LocalAddr       := FLocalAddr;
    FWorkerThread.AddrStr         := FAddrStr;
    FWorkerThread.LingerOnOff     := FLingerOnOff;
    FWorkerThread.LingerTimeout   := FLingerTimeout;
    FWorkerThread.OnOperationDone := OperationDoneConnect;
    FWorkerThread.OnClose         := SocketHasClosed;
    FWorkerThread.OnDoReadReady   := DoReadReady;
    FWorkerThread.OnChangeState   := ChangeState;
    FWorkerThread.Resume;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.ChangeState;
begin
    TriggerChangeState(FWorkerThread.OldState, FWorkerThread.State);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.TriggerChangeState(
    OldState, NewState : TIcsSocketState);
begin
    if Assigned(FOnChangeState) then
        FOnChangeState(Self, OldState, State);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
// Synchronized method
procedure TCustomIcsSocket.ReadReady;
begin
    if not FWorkerThread.Terminated then
        TriggerDataAvailable(FWorkerThread.LastError);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
// Called from within WorkerThread context
procedure TCustomIcsSocket.DoReadReady;
begin
    FWorkerThread.SynchronizeMethod(ReadReady);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.SocketHasClosed;
begin
    ShutdownThread(FWriterThread);
    WaitForThread(@FWriterThread);
    TriggerSessionClosed(FWorkerThread.LastError);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.OperationDoneConnect;
begin
    TriggerSessionConnected(FWorkerThread.LastError);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.OperationDoneListen;
begin
    TriggerSessionAvailable(FWorkerThread.LastError);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.AssignDefaultValue;
begin
    FillChar(sin, 0, Sizeof(sin));
    sin.sin_family     := AF_INET;
    FAddrFormat        := PF_INET;

    FPortAssigned      := FALSE;
    FAddrAssigned      := FALSE;
    FAddrResolved      := FALSE;
    FPortResolved      := FALSE;
    FProtoResolved     := FALSE;
    FLocalPortResolved := FALSE;

    FProtoAssigned     := TRUE;
    FProto             := IPPROTO_TCP;
    FProtoStr          := 'tcp';
    FType              := Integer(SOCK_STREAM);
    FLocalPortStr      := '0';
    FLocalAddr         := '0.0.0.0';

    FLingerOnOff       := wsLingerOn;
    FLingerTimeout     := 0;
    FHSocket           := INVALID_SOCKET;
    FReadCount         := 0;
    FFlushTimeout      := 60;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
constructor TCustomIcsSocket.Create(AOwner: TComponent);
{$IFDEF WIN32}
var
    LastError : LongInt;
{$ENDIF}
begin
    inherited Create(AOwner);
    FBufList       := TList.Create;
    FBufSize       := 1514;                { Default buffer size }
    FBufCritSect   := TCriticalSection.Create;
    FDnsResultList := TStringList.Create;
    FComponentOptions := [isoSyncEvents];
    AssignDefaultValue;
{$IFDEF WIN32}
    LastError := Ics_WSAStartup($101, GInitData);
    if LastError <> 0 then
        raise ESocketException.CreateFmt('WSAStartup error #%d', [LastError]);
{$ENDIF}
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
destructor TCustomIcsSocket.Destroy;
var
    OldState : TIcsSocketState;
begin
IcsSocketDisplay(Name + ': Destroy');
    if Assigned(FWorkerThread) then
        FWorkerThread.ComponentState := [csDestroying];
    if Assigned(FWriterThread) then
        FWriterThread.ComponentState := [csDestroying];
    try
        CancelDnsLookup;             { Cancel any pending dns lookup      }
    except
        { Ignore any exception here }
    end;

    if State <> wsClosed then begin  { Close the socket if not yet closed }
        OldState := State;
        Close;
        TriggerChangeState(OldState, wsClosed);
    end;

IcsSocketDisplay(Name + ': Destroy kill threads');
    KillWorkerAndWriterThreads;

    IcsSocketDisplay(Name + ': Destroy Delete Buffered Data');
    DeleteBufferedData;
    FBufList.Free;
    if Assigned(FBufCritSect) then begin
        FBufCritSect.Free;
        FBufCritSect := nil;
    end;
    FDnsResultList.Free;

{$IFDEF WIN32}
    Ics_WSACleanup;
{$ENDIF}
IcsSocketDisplay(Name + ': Destroy calling inherited');
    inherited Destroy;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.ShutdownThread(Thread : TIcsThread);
begin
    if Assigned(Thread) then begin
        IcsSocketDisplay(Name + ': Shutdown ' + Thread.Name);
        Thread.Terminate;
        Thread.SetEvent;
{$IFNDEF WIN32}
        kill(Thread.FPID, SIGUSR1);
{$ENDIF}
        if Thread.Suspended then
            Thread.Resume;
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.WaitForThread(PThread : PIcsThread);
begin
    if Assigned(PThread^) then begin
        IcsSocketDisplay(Name + ': WaitFor ' + PThread^.Name);
{$IFDEF WIN32}
        PThread^.WaitFor;
        PThread^.Free;
        PThread^ := nil;
{$ELSE}
        // A bug in Kylix hangup WaitFor, use this hack instead...
        while Assigned(PThread^) do begin
            if PThread^.FinishedFlag then begin
                PThread^.Free;
                PThread^ := nil;
                break;
            end;
            CheckSynchronize;
            Sleep(0);
        end;
{$ENDIF}
        IcsSocketDisplay(Name + ': WaitForThread Done');
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.KillWorkerAndWriterThreads;
begin
    ShutdownThread(FWorkerThread);
    ShutdownThread(FWriterThread);
    WaitForThread(@FWorkerThread);
    WaitForThread(@FWriterThread);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.DnsLookup(HostName : String);
var
    IPAddr  : TInAddr;
begin
IcsSocketDisplay(Name + ': DnsLookup');
    if HostName = '' then begin
        RaiseException('DNS lookup: invalid host name.');
        TriggerDnsLookupDone(WSAEINVAL);
        Exit;
    end;

    { Cancel any pending lookup }

    { Create worker thread if needed, check if busy if already exists }
    if not GetWorkerThread then begin
        RaiseException('DNS lookup: Component is busy.');
        TriggerDnsLookupDone(WSAEINPROGRESS);
        Exit;
    end;

    FDnsResult := '';
    FDnsResultList.Clear;

    IPAddr.S_addr := Ics_inet_addr(@HostName[1]);
    if u_long(IPAddr.S_addr) <> u_long(INADDR_NONE) then begin
        FDnsResult := StrPas(Ics_inet_ntoa(IPAddr));
        TriggerDnsLookupDone(0);
        Exit;
    end;

    FWorkerThread.Operation       := iwtGetHostByName;
    FWorkerThread.ParamString     := HostName;
    FWorkerThread.DnsResultList   := FDnsResultList;
    FWorkerThread.OnOperationDone := OperationDoneDnsLookup;
    FWorkerThread.Resume;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.OperationDoneDnsLookup;
begin
    if FDnsResultList.Count <= 0 then
        FDnsResult := ''
    else
        FDnsResult := FDnsResultList.Strings[0];
    TriggerDnsLookupDone(0);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.Dup(NewHSocket: TSocket);
begin
    if (NewHSocket = 0) or (NewHSocket = INVALID_SOCKET) then begin
        RaiseException('Dup');
        Exit;
    end;

    if State <> wsClosed then
        Close;
    FHsocket := NewHSocket;

    { Create worker thread if needed, check if busy if already exists }
    if not GetWorkerThread then begin
        RaiseException('Dup: Component is busy.');
        Exit;
    end;

    { Remove any data from the internal output buffer }
    { (should already be empty !)                     }
    DeleteBufferedData;

    FWorkerThread.State := wsConnecting;
    ChangeState;
    FWorkerThread.HSocketLocation := @FHSocket;
    FWorkerThread.Operation       := iwtDup;
    FWorkerThread.LingerOnOff     := FLingerOnOff;
    FWorkerThread.LingerTimeout   := FLingerTimeout;
    FWorkerThread.OnOperationDone := nil;
    FWorkerThread.OnDoReadReady   := DoReadReady;
    FWorkerThread.OnClose         := SocketHasClosed;
    FWorkerThread.OnChangeState   := ChangeState;
    FWorkerThread.Resume;

    // Wait until Workerthread really started (should be almost instantaneous)
    while (not FWorkerThread.Terminated) and
          (FWorkerThread.State <> wsConnected) do
        Sleep(0);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.Flush;
begin

end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function atoi(value : string) : Integer;
var
    i : Integer;
begin
    Result := 0;
    i := 1;
    while (i <= Length(Value)) and (Value[i] = ' ') do
        i := i + 1;
    while (i <= Length(Value)) and (Value[i] >= '0') and (Value[i] <= '9')do begin
        Result := Result * 10 + ord(Value[i]) - ord('0');
        i := i + 1;
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function IsDigit(Ch : Char) : Boolean;
begin
    Result := (ch >= '0') and (ch <= '9');
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
{ Check for a valid numeric dotted IP address such as 192.161.65.25         }
{ Accept leading and trailing spaces.                                       }
function WSocketIsDottedIP(const S : String) : Boolean;
var
    I          : Integer;
    DotCount   : Integer;
    NumVal     : Integer;
begin
    Result     := FALSE;
    DotCount   := 0;
    NumVal     := 0;
    I          := 1;
    { Skip leading spaces }
    while (S[I] = ' ') and (I <= Length(S)) do
        Inc(I);
    { Can't begin with a dot }
    if (I <= Length(S)) and (S[I] = '.') then
        Exit;
    { Scan full string }
    while I <= Length(S) do begin
        if S[I] = '.' then begin
            Inc(DotCount);
            if (DotCount > 3) or (NumVal > 255) then
                Exit;
            NumVal := 0;
            { A dot must be followed by a digit }
            if (I >= Length(S)) or (not (S[I + 1] in ['0'..'9'])) then
                Exit;
        end
        else if S[I] in ['0'..'9'] then
            NumVal := NumVal * 10 + Ord(S[I]) - Ord('0')
        else begin
            { Not a digit nor a dot. Accept spaces until end of string }
            while (S[I] = ' ') and (I <= Length(S)) do
                Inc(I);
            if I <= Length(S) then
                Exit;  { Not a space, do not accept }
            break;     { Only spaces, accept        }
        end;
        Inc(I);
    end;
    { We must have excatly 3 dots }
    if (DotCount <> 3) or (NumVal > 255) then
        Exit;
    Result := TRUE;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function IcsSocketResolveHost(InAddr : String) : TInAddr;
var
    szData  : array [0..256] of char;
    Phe     : Phostent;
    IPAddr  : u_long;
begin
    if (Length(InAddr) = 0) or (Length(InAddr) >= SizeOf(szData)) then
        raise ESocketException.Create('IcsSocketResolveHost: ''' + InAddr + ''' Invalid Hostname.');

    StrPCopy(szData, Trim(InAddr));
    if WSocketIsDottedIP(InAddr) then begin
        { Address is a dotted numeric address like 192.161.124.32 }
        IPAddr := Ics_inet_addr(szData);
        if IPAddr = u_long(INADDR_NONE) then begin
            if StrComp(szData, '255.255.255.255') = 0 then begin
                Result.S_addr := u_long(INADDR_BROADCAST);
                Exit;
            end;
            raise ESocketException.Create('IcsSocketResolveHost: ''' + InAddr + ''' Invalid IP address.');
        end;
        Result.S_addr := IPAddr;
        Exit;
    end;

    { Address is a hostname }
    Phe := Ics_gethostbyname(szData);
    if Phe = nil then
        raise ESocketException.CreateFmt(
                 'IcsSocketResolveHost: Cannot convert host address ''%s'', Error #%d',
                 [InAddr, WSAGetLastError]);
    Result.S_addr := PInAddr(Phe^.h_addr_list^)^.S_addr;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
{ Convert port name or number to number in host order (ftp -> 21)           }
function IcsSocketResolvePort(Port : String; Proto : String) : Word;
var
    szPort   : array [0..31] of char;
    szProto  : array [0..31] of char;
    Pse      : Pservent;
begin
    if (Length(Port) = 0) or (Length(Port) >= SizeOf(szPort)) then
        raise ESocketException.Create('IcsSocketResolvePort: Invalid Port.');

    if IsDigit(Port[1]) then
        Result := atoi(Port)
    else begin
        StrPCopy(szPort, Trim(Port));
        StrPCopy(szProto, Trim(Proto));
        if szProto[0] = #0 then
            Pse := Ics_getservbyname(szPort, nil)
        else
            Pse := Ics_getservbyname(szPort, szProto);
        if Pse = nil then
            raise ESocketException.CreateFmt(
                     'IcsSocketResolvePort: Cannot convert port ''%s'', Error #%d',
                     [Port, WSAGetLastError]);
        Result := Ics_ntohs(Pse^.s_port);
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function IcsSocketResolveProto(sProto : String) : Integer;
var
    szProto : array [0..31] of char;
    Ppe     : Pprotoent;
begin
    if (Length(sProto) = 0) or (Length(sProto) >= SizeOf(szProto)) then
        raise ESocketException.Create('IcsSocketResolveProto: Invalid Protocol.');

    sProto := Trim(sProto);
    if IsDigit(sProto[1]) then
        Result := atoi(sProto)
    else begin
        StrPCopy(szProto, sProto);
        ppe := Ics_getprotobyname(szProto);
        if Ppe = nil then
            raise ESocketException.CreateFmt(
                      'IcsSocketResolveProto: Cannot convert protocol ''%s'', Error #%d',
                      [sProto, WSAGetLastError]);
        Result := ppe^.p_proto;
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function TCustomIcsSocket.GetAddr: String;
begin
    Result := FAddrStr;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function TCustomIcsSocket.GetPeerAddr: String;
var
    saddr    : TSockAddr;
    saddrlen : Integer;
begin
    Result := 'error';
    if State = wsConnected then begin
        saddrlen := SizeOf(saddr);
        if Ics_getpeername(FHSocket, saddr, saddrlen) <> -1 then
            Result := Ics_inet_ntoa(saddr.sin_addr)
        else begin
            FLastError := WSAGetLastError;
            SocketError('GetPeerName');
            Exit;
        end;
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function TCustomIcsSocket.GetPeerName(
    var Name: TSockAddrIn;
    NameLen: Integer): Integer;
begin
    if State = wsConnected then
        Result := Ics_getpeername(FHSocket, TSockAddr(Name), NameLen)
    else
        Result := SOCKET_ERROR;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function TCustomIcsSocket.GetPeerPort: String;
var
    saddr    : TSockAddrIn;
    saddrlen : integer;
begin
    Result := 'error';
    if State = wsConnected then begin
        saddrlen := sizeof(saddr);
        if Ics_getpeername(FHSocket, TSockAddr(saddr), saddrlen) = 0 then
            Result := IntToStr(Ics_ntohs(saddr.sin_port))
        else begin
            SocketError('GetPeerPort');
            Exit;
        end;
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function TCustomIcsSocket.GetProto: String;
begin
    Result := '';
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function TCustomIcsSocket.GetRcvdCount: LongInt;
var
    Count : u_long;
begin
    if Ics_ioctlsocket(FHSocket, FIONREAD, Count) = SOCKET_ERROR then begin
        Result := -1;
        SocketError('ioctlSocket');
    end
    else
        Result := LongInt(Count);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function TCustomIcsSocket.GetRemotePort: String;
begin
    Result := FPortStr;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function TCustomIcsSocket.GetSendFlags: TIcsSocketSendFlags;
begin
    case FSendFlags of
    0       : Result := wsSendNormal;
    MSG_OOB : Result := wsSendUrgent;
    else
        RaiseException('Invalid internal SendFlags');
        Result := wsSendNormal;
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function TCustomIcsSocket.GetSockName(var saddr: TSockAddrIn;
  var saddrlen: Integer): integer;
begin
    Result := SOCKET_ERROR;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function TCustomIcsSocket.GetXPort: string;
begin
    Result := '';
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.Listen;
begin
    if not FPortAssigned then begin
        RaiseException('listen: port not assigned');
        Exit;
    end;

    if not FProtoAssigned then begin
        RaiseException('listen: protocol not assigned');
        Exit;
    end;

    if not FAddrAssigned then begin
        RaiseException('listen: address not assigned');
        Exit;
    end;

    { Remove any data from the internal output buffer }
    { (should already be empty !)                     }
    DeleteBufferedData;

    { Create worker thread if needed, check if busy if already exists }
    if not GetWorkerThread then begin
        RaiseException('Listen: Component is busy.');
        TriggerSessionAvailable(WSAEINPROGRESS);
        Exit;
    end;

    FWorkerThread.HSocketLocation := @FHSocket;
    FWorkerThread.ASocketLocation := @FASocket;
    FWorkerThread.Operation       := iwtListen;
    FWorkerThread.ProtoStr        := FProtoStr;
    FWorkerThread.PortStr         := FPortStr;
    FWorkerThread.LocalPortStr    := FLocalPortStr;
    FWorkerThread.LocalAddr       := FLocalAddr;
    FWorkerThread.AddrStr         := FAddrStr;
    FWorkerThread.LingerOnOff     := FLingerOnOff;
    FWorkerThread.LingerTimeout   := FLingerTimeout;
    FWorkerThread.OnOperationDone := OperationDoneListen;
    FWorkerThread.OnDoReadReady   := DoReadReady;
    FWorkerThread.OnClose         := SocketHasClosed;
    FWorkerThread.OnChangeState   := ChangeState;
    FWorkerThread.Resume;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function TCustomIcsSocket.PeekData(Buffer: Pointer;
  BufferSize: integer): integer;
begin
    Result := SOCKET_ERROR;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.RaiseException(const Msg: String);
begin
IcsSocketDisplay('RaiseException');
    if Assigned(FOnError) then
        TriggerError
    else
        raise ESocketException.Create(Msg);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
//procedure TCustomIcsSocket.RaiseExceptionFmt(const Fmt: String;
//  args: array of const);
//begin
//
//end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
{ DoRecv is a simple wrapper around winsock recv function to make it        }
{ a virtual function.                                                       }
function TCustomIcsSocket.DoRecv(
    var Buffer;
    BufferSize : Integer;
    Flags      : Integer) : Integer;
begin
    Result := Ics_recv(FWorkerThread.HSocket, Buffer, BufferSize, Flags);
    if Result < 0 then begin
        FWorkerThread.Error := GetLastError;
IcsSocketDisplay(Name + ': recv returned an error ' + IntToStr(FWorkerThread.Error));
    end
    else
        FWorkerThread.Error := 0;
    if Result = 0 then begin
        // Graceful close
        FWorkerThread.ClosedByRemoteError := FWorkerThread.Error;
        FWorkerThread.ClosedByRemote      := TRUE;
    end
    else if (FWorkerThread.Error = WSAESHUTDOWN) or
            (FWorkerThread.Error = WSAECONNRESET) or
            (FWorkerThread.Error = WSAECONNABORTED) then begin
        FWorkerThread.ClosedByRemoteError := FWorkerThread.Error;
        FWorkerThread.ClosedByRemote      := TRUE;
    end;

    FRcvdFlag := (Result >= BufferSize);
    FWorkerThread.SetEvent;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
{ The socket is non-blocking, so this routine will only receive as much     }
{ data as it is available.                                                  }
function TCustomIcsSocket.Receive(Buffer: Pointer; BufferSize: integer): integer;
begin
    Result := DoRecv(Buffer^, BufferSize, 0);
    if Result < 0 then
        FLastError := WSAGetLastError
    else
        FReadCount := FReadCount + Result;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function TCustomIcsSocket.ReceiveFrom(Buffer: Pointer; BufferSize: Integer;
  var From: TSockAddr; var FromLen: Integer): integer;
begin
    Result := 0;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function TCustomIcsSocket.ReceiveStr: String;
var
    lCount : LongInt;
begin
    SetLength(Result, 0);
    lCount := GetRcvdCount;
    if lCount > 0 then begin
        SetLength(Result, lCount);
        lCount := Receive(@Result[1], lCount);
        if lCount > 0 then
            SetLength(Result, lCount)
        else
            SetLength(Result, 0);
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.Release;
begin

end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.ReverseDnsLookup(HostAddr: String);
begin

end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function SearchChar(Data : PChar; Len : Integer; Ch : Char) : PChar;
begin
    while Len > 0 do begin
        Len := Len - 1;
        if Data^ = Ch then begin
            Result := Data;
            exit;
        end;
        Data := Data + 1;
    end;
    Result := nil;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
// Executed from within WriteThread context
function TCustomIcsSocket.RealSend(Data : Pointer; Len : Integer) : Integer;
begin
    if FType = Integer(SOCK_DGRAM) then
        Result := Ics_sendto(FHSocket, Data^, Len, FSendFlags,
                             TSockAddr(sin), SizeOf(sin))
    else
        Result := Ics_send(FHSocket, Data^, Len, FSendFlags);
    if Result > 0 then begin
        FSendDataCount := Result;
        FWriterThread.SynchronizeMethod(CallSendData);
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.CallSendData;
begin
    TriggerSendData(FSendDataCount);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.DataSent;
begin
    if Assigned(FOnDataSent) then
        FOnDataSent(Self, 0);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.DoDataSent;
begin
    FWriterThread.SynchronizeMethod(DataSent);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
// Executed from within WriteThread context
procedure TCustomIcsSocket.TryToSend;
var
    oBuffer   : TIcsBuffer;
    Len       : Integer;
    Count     : Integer;
    Data      : Pointer;
    LastError : Integer;
    p         : PChar;
    bMore     : Boolean;
begin
IcsSocketDisplay('TryToSend');
    if (FHSocket = INVALID_SOCKET) or                { No more socket      }
       (FBufList.Count = 0) or                       { Nothing to send     }
       (bMoreFlag and (nMoreCnt >= nMoreMax)) then   { Waiting more signal }
        Exit;

    FBufCritSect.Enter;
    try
        bMore := TRUE;
        while bMore do begin
            oBuffer := FBufList.First;
            Data    := oBuffer.Peek(Len);
            if Len <= 0 then begin
                { Buffer is empty }
                if FBufList.Count <= 1 then begin
                    { Every thing has been sent }
                    bAllSent := TRUE;
                    bMore    := FALSE;
                end
                else begin
                    oBuffer.Free;
                    FBufList.Delete(0);
                    FBufList.Pack;
                end;
            end
            else begin
                if bMoreFlag then begin
                    p := SearchChar(Data, Len, #10);
                    if Assigned(p) then begin
                        len := p - PChar(Data) + 1;
                        nMoreCnt := nMoreCnt + 1;
                        if nMoreCnt >= nMoreMax then
                            bMore := FALSE;
                    end;
                end;

                Count := RealSend(Data, Len);

                if Count = 0 then
                    bMore := FALSE  { Closed by remote }
                else if count = SOCKET_ERROR then begin
                    LastError := GetLastError;
                    if (LastError = WSAECONNRESET) or (LastError = WSAENOTSOCK) or
                       (LastError = WSAENOTCONN)   or (LastError = WSAEINVAL)   or
                       (LastError = WSAECONNABORTED)     { 07/05/99 }
                    then begin
                        FCloseInvoked := TRUE;           { 23/07/98 }
                        Close;
                        TriggerSessionClosed(LastError); { 23/07/98 }
                    end
                    else if LastError <> WSAEWOULDBLOCK then begin
                        FLastError := LastError;
                        SocketError('TryToSend failed');
                        Exit;
                    end;
                    bMore := FALSE;
                end
                else begin
                    oBuffer.Remove(Count);
                    if Count < Len then begin
                        { Could not write as much as we wanted. Stop sending }
                        bWrite := FALSE;
                        bMore  := FALSE;
                        // Unblock WriteThread on the event, it will block on
                        // select instead
                        FWriterThread.SetEvent;
                    end;
                end;
            end;
        end;
    finally
        FBufCritSect.Leave;
    end;
    if bAllSent then begin
        // Will block WriterThread
        FWriterThread.FEventObject.ResetEvent;
        DoDataSent;
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.PutStringInSendBuffer(Str : String);
begin
    PutDataInSendBuffer(@Str[1], Length(Str));
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.PutDataInSendBuffer(Data : Pointer; Len : Integer);
var
    oBuffer  : TIcsBuffer;
    cWritten : Integer;
    bMore    : Boolean;
begin
    if Len <= 0 then
        exit;

    FBufCritSect.Enter;
    try
        if FBufList.Count = 0 then begin
            oBuffer := TIcsBuffer.Create(FBufSize);
            FBufList.Add(oBuffer);
        end
        else
            oBuffer := FBufList.Last;

        bMore := TRUE;
        while bMore do begin
            cWritten := oBuffer.Write(Data, Len);
            if cWritten >= Len then
                bMore := FALSE
            else begin
                Len  := Len - cWritten;
                Data := PChar(Data) + cWritten;
                if Len < 0 then
                    bMore := FALSE
                else begin
                    oBuffer := TIcsBuffer.Create(FBufSize);
                    FBufList.Add(oBuffer);
                end;
            end;
        end;
    finally
        FBufCritSect.Leave;
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
{ Return -1 if error, else return number of byte written                    }
function TCustomIcsSocket.Send(Data: Pointer; Len: Integer): integer;
begin
    if State <> wsConnected then begin
        FLastError := WSAENOTCONN;
        SocketError('Send');
        Result     := -1;
        Exit;
    end;

    bAllSent := FALSE;
    if Len <= 0 then
        Result := 0
    else begin
        Result   := Len;
        PutDataInSendBuffer(Data, Len);
    end;

    if bAllSent then
        Exit;

    if GetWriterThread then begin
        FWriterThread.HSocketLocation := @FHSocket;
        FWriterThread.OnWriteReady    := TryToSend;
        FWriterThread.Suspended       := FALSE;
    end;

    // Unblock WriterThread
    FWriterThread.SetEvent;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
{ Return -1 if error, else return number of byte written                    }
function TCustomIcsSocket.SendStr(const Str : String) : integer;
begin
    if Length(Str) > 0 then
        Result := Send(@Str[1], Length(Str))
    else
        Result := 0;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.SendText(const Value : String);
begin
    SendStr(Value);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function TCustomIcsSocket.SendTo(Dest: TSockAddr; DestLen: Integer;
  Data: Pointer; Len: Integer): integer;
begin
    Result := 0;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.SetAddr(InAddr: String);
begin
    if FAddrAssigned and (FAddrStr = InAddr) then
        Exit;

    if State <> wsClosed then begin
        RaiseException('Cannot change Addr if not closed');
        Exit;
    end;

    FAddrStr := Trim(InAddr);
    if Length(FAddrStr) = 0 then begin
        FAddrAssigned := FALSE;
        Exit;
    end;

    FAddrResolved       := FALSE;
    FAddrAssigned       := TRUE;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.SetLingerOption;
begin

end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.SetLocalAddr(sLocalAddr: String);
begin

end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.SetLocalPort(sLocalPort: String);
begin

end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.SetProto(sProto: String);
begin
    if FProtoAssigned and (sProto = FProtoStr) then
        Exit;

    if State <> wsClosed then begin
        RaiseException('Cannot change Proto if not closed');
        Exit;
    end;

    FProtoStr := Trim(sProto);
    if Length(FProtoStr) = 0 then begin
        FProtoAssigned := FALSE;
        Exit;
    end;

    FProtoResolved := FALSE;
    FProtoAssigned := TRUE;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.SetRemotePort(sPort: String);
begin
    if FPortAssigned and (FPortStr = sPort) then
        Exit;

    if State <> wsClosed then begin
        RaiseException('Cannot change Port if not closed');
        Exit;
    end;

    FPortStr := Trim(sPort);
    if Length(FPortStr) = 0 then begin
        FPortAssigned := FALSE;
        Exit;
    end;

    FPortResolved := FALSE;
    FPortAssigned := TRUE;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.SetSendFlags(newValue: TIcsSocketSendFlags);
begin
    case newValue of
    wsSendNormal: FSendFlags := 0;
    wsSendUrgent: FSendFlags := MSG_OOB;
    else
        RaiseException('Invalid SendFlags');
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.Shutdown(How: Integer);
begin
    if FHSocket <> INVALID_SOCKET then
        Ics_shutdown(FHSocket, How);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.TimerClear(var tvp: TTimeVal);
begin
   tvp.tv_sec  := 0;
   tvp.tv_usec := 0;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function TCustomIcsSocket.TimerCmp(
   var tvp, uvp: TTimeVal;
   IsEqual: Boolean): Boolean;
begin
    Result := (tvp.tv_sec = uvp.tv_sec) and (tvp.tv_usec = uvp.tv_usec);
    if not IsEqual then
        Result := not Result;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function TCustomIcsSocket.TimerIsSet(var tvp: TTimeVal): Boolean;
begin
    Result := (tvp.tv_sec <> 0) or (tvp.tv_usec <> 0);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.TriggerSendData(BytesSent : Integer);
begin
    if Assigned(FOnSendData) then
        FOnSendData(Self, BytesSent);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.TriggerSessionClosed(Error : Word);
begin
    if Assigned(FOnSessionClosed) then
        FOnSessionClosed(Self, Error);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function TCustomIcsSocket.TriggerDataAvailable(Error: Word): Boolean;
begin
    Result := Assigned(FOnDataAvailable);
    if not Result then
        Exit;
    FOnDataAvailable(Self, Error);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.TriggerDNSLookupDone(Error: Word);
begin
    if Assigned(FOnDNSLookupDone) then
        FOnDNSLookupDone(Self, Error);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.TriggerError;
begin

end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.TriggerSessionAvailable(Error : Word);
begin
    if Assigned(FOnSessionAvailable) then
        FOnSessionAvailable(Self, Error);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.TriggerSessionConnected(Error: Word);
begin
    if Assigned(FOnSessionConnected) then
        FOnSessionConnected(Self, Error);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.SocketError(SockFunc: String);
var
    Line   : String;
begin
    Line  := 'Error '+ IntToStr(FLastError) + ' in function ' + SockFunc +
             #13#10 + IcsSocketErrorDesc(FLastError);

IcsSocketDisplay('SocketError: ' + Line);
    if (FHSocket <> INVALID_SOCKET) and
       ((FLastError = WSAECONNRESET) or
        (FLastError = WSAENOTCONN))   then begin
IcsSocketDisplay('SocketError LastError=' + IntToStr(FLastError));
        Ics_closesocket(FHSocket);
        FHSocket := INVALID_SOCKET;
        // ChangeState(wsClosed);
    end;

    RaiseException(Line);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function IcsSocketErrorDesc(Error: Integer) : String;
begin
    case Error of
    0:
      Result := 'No Error';
    WSAEINTR:
      Result := 'Interrupted system call';
    WSAEBADF:
      Result := 'Bad file number';
    WSAEACCES:
      Result := 'Permission denied';
    WSAEFAULT:
      Result := 'Bad address';
    WSAEINVAL:
      Result := 'Invalid argument';
    WSAEMFILE:
      Result := 'Too many open files';
    WSAEWOULDBLOCK:
      Result := 'Operation would block';
    WSAEINPROGRESS:
      Result := 'Operation now in progress';
    WSAEALREADY:
      Result := 'Operation already in progress';
    WSAENOTSOCK:
      Result := 'Socket operation on non-socket';
    WSAEDESTADDRREQ:
      Result := 'Destination address required';
    WSAEMSGSIZE:
      Result := 'Message too long';
    WSAEPROTOTYPE:
      Result := 'Protocol wrong type for socket';
    WSAENOPROTOOPT:
      Result := 'Protocol not available';
    WSAEPROTONOSUPPORT:
      Result := 'Protocol not supported';
    WSAESOCKTNOSUPPORT:
      Result := 'Socket type not supported';
    WSAEOPNOTSUPP:
      Result := 'Operation not supported on socket';
    WSAEPFNOSUPPORT:
      Result := 'Protocol family not supported';
    WSAEAFNOSUPPORT:
      Result := 'Address family not supported by protocol family';
    WSAEADDRINUSE:
      Result := 'Address already in use';
    WSAEADDRNOTAVAIL:
      Result := 'Address not available';
    WSAENETDOWN:
      Result := 'Network is down';
    WSAENETUNREACH:
      Result := 'Network is unreachable';
    WSAENETRESET:
      Result := 'Network dropped connection on reset';
    WSAECONNABORTED:
      Result := 'Connection aborted';
    WSAECONNRESET:
      Result := 'Connection reset by peer';
    WSAENOBUFS:
      Result := 'No buffer space available';
    WSAEISCONN:
      Result := 'Socket is already connected';
    WSAENOTCONN:
      Result := 'Socket is not connected';
    WSAESHUTDOWN:
      Result := 'Can''t send after socket shutdown';
    WSAETOOMANYREFS:
      Result := 'Too many references: can''t splice';
    WSAETIMEDOUT:
      Result := 'Connection timed out';
    WSAECONNREFUSED:
      Result := 'Connection refused';
    WSAELOOP:
      Result := 'Too many levels of symbolic links';
    WSAENAMETOOLONG:
      Result := 'File name too long';
    WSAEHOSTDOWN:
      Result := 'Host is down';
    WSAEHOSTUNREACH:
      Result := 'No route to host';
    WSAENOTEMPTY:
      Result := 'Directory not empty';
    WSAEPROCLIM:
      Result := 'Too many processes';
    WSAEUSERS:
      Result := 'Too many users';
    WSAEDQUOT:
      Result := 'Disc quota exceeded';
    WSAESTALE:
      Result := 'Stale NFS file handle';
    WSAEREMOTE:
      Result := 'Too many levels of remote in path';
    WSASYSNOTREADY:
      Result := 'Network sub-system is unusable';
    WSAVERNOTSUPPORTED:
      Result := 'WinSock DLL cannot support this application';
    WSANOTINITIALISED:
      Result := 'WinSock not initialized';
    WSAHOST_NOT_FOUND:
      Result := 'Host not found';
    WSATRY_AGAIN:
      Result := 'Non-authoritative host not found';
    WSANO_RECOVERY:
      Result := 'Non-recoverable error';
    WSANO_DATA:
      Result := 'No Data';
    icsSocksNoError:
      Result := 'Socks no error';
    icsSocksProtocolError:
      Result := 'Socks protocol error';
    icsSocksVersionError:
      Result := 'Socks version error';
    icsSocksAuthMethodError:
      Result := 'Socks authentication method error';
    icsSocksGeneralFailure:
      Result := 'Socks general failure';
    icsSocksConnectionNotAllowed:
      Result := 'Socks connection not allowed';
    icsSocksNetworkUnreachable:
      Result := 'Socks network unreachable';
    icsSocksHostUnreachable:
      Result := 'Socks host unreachable';
    icsSocksConnectionRefused:
      Result := 'Socks connection refused';
    icsSocksTtlExpired:
      Result := 'Socks time to live expired';
    icsSocksUnknownCommand:
      Result := 'Socks unknown command';
    icsSocksUnknownAddressType:
      Result := 'Socks Unknown address';
    icsSocksUnassignedError:
      Result := 'Socks unassigned error';
    icsSocksInternalError:
      Result := 'Socks internal error';
    icsSocksDataReceiveError:
      Result := 'Socks data received error';
    icsSocksAuthenticationFailed:
      Result := 'Socks authentication failed';
    icsSocksRejectedOrFailed:
      Result := 'Socks rejected failed';
    icsSocksHostResolutionFailed:
      Result := 'Socks host resolution failed';
    else
      Result := 'Not a socket error';
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomIcsSocket.WaitForClose;
begin

end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TIcsWorkerThread.SetLingerOption;
var
    iStatus : integer;
    li      : TLinger;
begin
    if FLingerOnOff = wsLingerNoSet then
        Exit;                            { Option set is disabled, ignore }

    if HSocket = INVALID_SOCKET then begin
        raise Exception.Create('Cannot set linger option at this time');
        Exit;
    end;

    li.l_onoff  := Ord(FLingerOnOff);    { 0/1 = disable/enable linger }
    li.l_linger := FLingerTimeout;       { timeout in seconds          }
    iStatus     := Ics_setsockopt(HSocket, SOL_SOCKET,
                              SO_LINGER, @li, SizeOf(li));

    if iStatus <> 0 then begin
        FLastError := WSAGetLastError;
        //SocketError('setsockopt(SO_LINGER)');
        Exit;
    end;
end;


{$IFDEF never}
            Count := recv(FHSocket, Buf, SizeOf(Buf), 0);
            if Count = 0 then begin
                // Graceful close
                SynchronizeMethod(FOnClose);
                Exit;
            end
            else if Count < 0 then begin
                // Abortive close
                FLastError := WSAGetLastError;
                SynchronizeMethod(FOnClose);
                Exit;
            end;
{$ENDIF}


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TIcsWorkerThread.OpRead;
var
    ReadFds   : TFDSet;
    ExceptFds : TFDSet;
    Count     : Integer;
//  Buf       : array [0..1023] of char;
begin
    FOperation := iwtNoop;
    FLastError := 0;
    FD_ZERO(ReadFds);
    FD_ZERO(ExceptFds);
    while not Terminated do begin
        if ClosedByRemote then begin
            IcsSocketDisplay(Name + ': Closed By Remote');
            Ics_closesocket(HSocket);
            HSocket    := INVALID_SOCKET;
            FLastError := ClosedByRemoteError;
            // Should I clear WSAESHUTDOWN error because it is not really
            // an error but a graceful close ?
            Terminate;
            break;
        end;
        FD_SET(HSocket, ReadFds);
        FD_SET(HSocket, ExceptFds);
IcsSocketDisplay(Name + ': WorkerThread Waiting in select');
        Count := select(HSocket + 1, @ReadFds, nil, @ExceptFds, nil);
IcsSocketDisplay(Name + ': WorkerThread select done');
        if Count < 0 then begin
            FLastError := WSAGetLastError;
            if (FLastError = WSAEINTR) and FCloseDelayedFlag then
                FLastError := 0;
            Exit;
        end;
        if Count = 0 then
            continue;
        if FD_ISSET(HSocket, ReadFds) then begin
            if Assigned(FOnDoReadReady) then
                FOnDoReadReady;
            // Event is set by Receive procedure
IcsSocketDisplay(Name + ': WorkerThread waiting for Event');
            WaitEvent;
IcsSocketDisplay(Name + ': WorkerThread Event set');
        end;
        if FD_ISSET(HSocket, ExceptFds) then begin
            SynchronizeMethod(FOnSocketExcept);
            Ics_closesocket(HSocket);
            HSocket := INVALID_SOCKET;
            Terminate;
            Exit;
        end;
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TIcsWorkerThread.OpListenStart;
var
    iStatus : integer;
begin
    FillChar(Fsin, 0, Sizeof(Fsin));
    Fsin.sin_family := AF_INET;
    FLastError      := 0;
    FOperation      := iwtNoop;
    try
        if not FProtoResolved then begin
            { The next line will trigger an exception in case of failure }
            FProto := IcsSocketResolveProto(FProtoStr);
            if FProto = IPPROTO_UDP then
                FType := Integer(SOCK_DGRAM)
            else
                FType := Integer(SOCK_STREAM);
            FProtoResolved := TRUE;
        end;

        if not FPortResolved then begin
            { The next line will trigger an exception in case of failure }
            FPortNum      := IcsSocketResolvePort(FPortStr, FProtoStr);
            Fsin.sin_port := Ics_htons(FPortNum);
            FPortResolved := TRUE;
        end;

        if not FLocalPortResolved then begin
            { The next line will trigger an exception in case of failure }
            FLocalPortNum      := IcsSocketResolvePort(FLocalPortStr, FProtoStr);
            FLocalPortResolved := TRUE;
        end;

        if not FAddrResolved then begin
            { The next line will trigger an exception in case of failure }
            Fsin.sin_addr.s_addr := IcsSocketResolveHost(FAddrStr).s_addr;
            FAddrResolved := TRUE;
        end;
    except
        on E:Exception do begin
            FLastError := WSAGetLastError;
            ChangeState(wsClosed);
            raise exception.Create('listen: ' + E.Message);
            Exit;
        end;
    end;

    HSocket := Ics_socket(PF_INET, FType, FProto);
    if HSocket = INVALID_SOCKET then begin
        ChangeState(wsClosed);
        FLastError := WSAGetLastError;
        Exit;
    end;

    iStatus := Ics_bind(HSocket, TSockAddr(Fsin), sizeof(Fsin));
    if iStatus = 0 then
        ChangeState(wsBound)
    else begin
        FLastError := WSAGetLastError;
        Ics_closesocket(HSocket);
        HSocket := INVALID_SOCKET;
        ChangeState(wsClosed);
        Exit;
    end;

    if FType = Integer(SOCK_DGRAM) then begin
        ChangeState(wsListening);
        ChangeState(wsConnected);
        //TriggerSessionConnected(0);
    end
    else if FType = Integer(SOCK_STREAM) then begin
        iStatus    := Ics_listen(HSocket, 5);
        if iStatus = 0 then begin
            ChangeState(wsListening);
            OpAccept;
            FOperation := iwtAccept;
        end
        else begin
            FLastError := WSAGetLastError;
            Ics_closesocket(HSocket);
            HSocket := INVALID_SOCKET;
            ChangeState(wsClosed);
        end;
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TIcsWorkerThread.OpAccept;
var
    Len     : integer;
    Sin     : TSockAddrIn;
begin
    FLastError := 0;
    FOperation := iwtNoop;
    Len        := SizeOf(Sin);
IcsSocketDisplay(Name + ': call accept');
    ASocket    := Ics_accept(HSocket, Sin, Len);
IcsSocketDisplay(Name + ': accept done');
    if ASocket = INVALID_SOCKET then begin
        FLastError := WSAGetLastError;
        if FCloseDelayedFlag then begin
            FLastError := 0;
            ChangeState(wsClosed);
            if Assigned(FOnClose) then
                SynchronizeMethod(FOnClose);
            Terminate;
        end;
    end
    else
        Foperation := iwtAccept;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TIcsWorkerThread.OpDup;
var
    iStatus : integer;
    optval  : integer;
begin
    SetLingerOption;

    optval  := -1;
    iStatus := Ics_setsockopt(HSocket, SOL_SOCKET,
                          SO_KEEPALIVE, @optval, SizeOf(optval));

    if iStatus <> 0 then begin
        FLastError := WSAGetLastError;
        //SocketError('setsockopt(SO_KEEPALIVE)');
        Ics_closesocket(HSocket);
        HSocket := INVALID_SOCKET;
        ChangeState(wsClosed);
        Exit;
    end;
    ChangeState(wsConnected);
    if not SetNonBlocking then
        Exit;
    FOperation := iwtRead;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TIcsWorkerThread.OpSocksConnect;
begin
    FillChar(Fsin, 0, Sizeof(Fsin));
    Fsin.sin_family := AF_INET;
    FOperation      := iwtNoop;
    FLastError      := 0;
    try
        if not FProtoResolved then begin
            { The next line will trigger an exception in case of failure }
            FProto := IcsSocketResolveProto(FProtoStr);
            if FProto = IPPROTO_UDP then
                FType := Integer(SOCK_DGRAM)
            else
                FType := Integer(SOCK_STREAM);
            FProtoResolved := TRUE;
        end;

        if not FPortResolved then begin
            { The next line will trigger an exception in case of failure }
            FPortNum      := IcsSocketResolvePort(FSocksPort, FProtoStr);
            Fsin.sin_port := Ics_htons(FPortNum);
            FPortNum      := IcsSocketResolvePort(FPortStr, FProtoStr);
            FPortResolved := TRUE;
        end;

        if not FLocalPortResolved then begin
            { The next line will trigger an exception in case of failure }
            FLocalPortNum      := IcsSocketResolvePort(FLocalPortStr, FProtoStr);
            FLocalPortResolved := TRUE;
        end;

        if not FAddrResolved then begin
            { The next line will trigger an exception in case of failure }
            Fsin.sin_addr.s_addr := IcsSocketResolveHost(FSocksServer).s_addr;
            FAddrResolved := TRUE;
        end;
    except
        on E:Exception do begin
            FLastError := WSAGetLastError;
            ChangeState(wsClosed);
            raise exception.Create('SocksConnect: ' + E.Message);
            Exit;
        end;
    end;
    OpCommonConnect;
    if FLastError <> 0 then
        Exit;
    SocksSessionConnected;
    if FLastError <> 0 then
        Exit;
    SocksDoConnect;
    if FLastError <> 0 then
        Exit;
    if not SetNonBlocking then
        Exit;
    FOperation := iwtRead;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TIcsWorkerThread.OpConnect;
begin
    FillChar(Fsin, 0, Sizeof(Fsin));
    Fsin.sin_family   := AF_INET;
    FOperation        := iwtNoop;
    FLastError        := 0;
    try
        if not FProtoResolved then begin
            { The next line will trigger an exception in case of failure }
            FProto := IcsSocketResolveProto(FProtoStr);
            if FProto = IPPROTO_UDP then
                FType := Integer(SOCK_DGRAM)
            else
                FType := Integer(SOCK_STREAM);
            FProtoResolved := TRUE;
        end;

        if not FPortResolved then begin
            { The next line will trigger an exception in case of failure }
            FPortNum      := IcsSocketResolvePort(FPortStr, FProtoStr);
            Fsin.sin_port := Ics_htons(FPortNum);
            FPortResolved := TRUE;
        end;

        if not FLocalPortResolved then begin
            { The next line will trigger an exception in case of failure }
            FLocalPortNum      := IcsSocketResolvePort(FLocalPortStr, FProtoStr);
            FLocalPortResolved := TRUE;
        end;

        if not FAddrResolved then begin
            { The next line will trigger an exception in case of failure }
            Fsin.sin_addr.s_addr := IcsSocketResolveHost(FAddrStr).s_addr;
            FAddrResolved := TRUE;
        end;
    except
        on E:Exception do begin
            FLastError := WSAGetLastError;
            ChangeState(wsClosed);
            raise exception.Create('connect: ' + E.Message);
            Exit;
        end;
    end;
    OpCommonConnect;
    if not SetNonBlocking then
        Exit;
    FOperation := iwtRead;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TIcsWorkerThread.OpCommonConnect;
var
    iStatus : integer;
    optval  : integer;
begin
    HSocket := Ics_socket(PF_INET, FType, FProto);
    if HSocket = INVALID_SOCKET then begin
        ChangeState(wsClosed);
        FLastError := WSAGetLastError;
        Exit;
    end;
    ChangeState(wsOpened);

    if FType = Integer(SOCK_DGRAM) then begin
        BindSocket;
        if Fsin.sin_addr.S_addr = u_long(INADDR_BROADCAST) then begin
            OptVal  := 1;
            iStatus := Ics_setsockopt(HSocket, SOL_SOCKET, SO_BROADCAST,
                                      PChar(@OptVal), SizeOf(OptVal));
            if iStatus <> 0 then begin
                FLastError := WSAGetLastError;
                Ics_closesocket(HSocket);
                HSocket := INVALID_SOCKET;
                ChangeState(wsClosed);
                //SocketError('setsockopt(SO_BROADCAST)');
                Exit;
            end;
        end;
    end
    else begin
        { Socket type is SOCK_STREAM }
        optval  := -1;
        iStatus := Ics_setsockopt(HSocket, SOL_SOCKET,
                                  SO_REUSEADDR, @optval, SizeOf(optval));

        if iStatus <> 0 then begin
            FLastError := WSAGetLastError;
            //SocketError('setsockopt(SO_REUSEADDR)');
            Ics_closesocket(HSocket);
            HSocket := INVALID_SOCKET;
            ChangeState(wsClosed);
            Exit;
        end;

        SetLingerOption;

        optval  := -1;
        iStatus := Ics_setsockopt(HSocket, SOL_SOCKET,
                                  SO_KEEPALIVE, @optval, SizeOf(optval));

        if iStatus <> 0 then begin
            FLastError := WSAGetLastError;
            //SocketError('setsockopt(SO_KEEPALIVE)');
            Ics_closesocket(HSocket);
            HSocket := INVALID_SOCKET;
            ChangeState(wsClosed);
            Exit;
        end;

        if (FLocalPortNum <> 0) or (FLocalAddr <> '0.0.0.0') then
            BindSocket;
    end;

    if FType = Integer(SOCK_DGRAM) then begin
        ChangeState(wsConnected);
    end
    else begin
        ChangeState(wsConnecting);
        iStatus := Ics_connect(HSocket, TSockAddr(Fsin), sizeof(Fsin));
        if iStatus <> 0 then begin
            FLastError:= WSAGetLastError;
            //SocketError('Connect');
            Ics_closesocket(HSocket);
            HSocket := INVALID_SOCKET;
            ChangeState(wsClosed);
            Exit;
        end;
        ChangeState(wsConnected);
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function TIcsWorkerThread.SetNonBlocking : Boolean;
var
    optval  : u_long;
begin
    // Set non-blocking I/O
    OptVal := u_long(-1);
    if Ics_ioctlsocket(HSocket, u_long(FIONBIO), OptVal) = SOCKET_ERROR then begin
        FLastError:= WSAGetLastError;
        Ics_closesocket(HSocket);
        HSocket := INVALID_SOCKET;
        ChangeState(wsClosed);
        Result := FALSE;
    end
    else
        Result := TRUE;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TIcsWorkerThread.OpGetHostByName;
var
    Phe     : Phostent;
begin
    FOperation := iwtNoop;
    if Assigned(FDnsResultList) then
        FDnsResultList.Clear;
    Phe := Ics_gethostbyname(PChar(ParamString));
    if (phe <> nil) and Assigned(FDnsResultList) then
        GetIpList(Phe, FDnsResultList);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
constructor TIcsWorkerThread.Create(CreateSuspended : Boolean);
begin
    inherited Create(TRUE);
{$IFNDEF WIN32}
    signal(SIGUSR1, IcsWorkerThreadSignalHandler);
{$ENDIF}
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TIcsWorkerThread.SetAddrStr(NewValue : String);
begin
    FAddrStr      := NewValue;
    FAddrResolved := FALSE;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TIcsWorkerThread.SetProtoStr(NewValue : String);
begin
    FProtoStr      := NewValue;
    FProtoResolved := FALSE;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TIcsWorkerThread.SetPortStr(NewValue : String);
begin
    FPortStr      := NewValue;
    FPortResolved := FALSE;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TIcsWorkerThread.Execute;
begin
{$IFDEF WIN32}
    FPID := Integer(GetCurrentThreadID);
{$ELSE}
    FPID := getpid;
{$ENDIF}
    IcsSocketDisplay(Name + ': WorkerThread pid=' + ThreadIdToStr(FPID));
    while not Terminated do begin
        try
            case FOperation of
            // Each operation must set FOperation
            // to iwtNoop or the next operation
            iwtGetHostByName : OpGetHostByName;
            iwtConnect       : OpConnect;
            iwtSocksConnect  : OpSocksConnect;
            iwtRead          : OpRead;
            iwtListen        : OpListenStart;
            iwtAccept        : OpAccept;
            iwtDup           : OpDup;
            else
                FOperation := iwtNoop;
            end;
        except
            // Ignore exceptions here FLastError already reflect failure
        end;
        if Terminated then
            break;
        if Assigned(FOnOperationDone) then begin
            SynchronizeMethod(FOnOperationDone);
            if FOperation <> iwtAccept then
                FOnOperationDone := nil;
        end;
        if FCloseDelayedFlag then begin
            FCloseDelayedFlag := FALSE;
            if HSocket <> INVALID_SOCKET then begin
                Ics_closesocket(HSocket);
                HSocket := INVALID_SOCKET;
            end;
            ChangeState(wsClosed);
            if Assigned(FOnClose) then
                SynchronizeMethod(FOnClose);
            Terminate;
            break;
        end;
        if FOperation = iwtNoop then begin
            if not Terminated then
                Suspend;
        end;
    end;
    IcsSocketDisplay(Name + ': WorkerThread.Execute finished');
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
// This is not called in IcsWorkerThread context but from main thread
procedure TIcsWorkerThread.SocketClose;
begin
    if HSocket <> INVALID_SOCKET then begin
        Ics_closesocket(HSocket);
        HSocket := INVALID_SOCKET;
    end;
    Terminate;
    if Suspended then
        Resume;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
constructor TIcsWriterThread.Create(CreateSuspended : Boolean);
begin
    inherited Create(TRUE);
{$IFNDEF WIN32}
//    signal(SIGUSR1, IcsWriterThreadSignalHandler);
{$ENDIF}
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TIcsWriterThread.Execute;
var
    WriteFds  : TFDSet;
    Count     : Integer;
begin
{$IFDEF WIN32}
    FPID := Integer(GetCurrentThreadID);
{$ELSE}
    FPID := getpid;
{$ENDIF}
    IcsSocketDisplay(Name + ': WriterThread pid=' + ThreadIdToStr(FPID));

    FLastError := 0;
    // When starting, first try to send data already in buffer
    if Assigned(FOnWriteReady) then
        FOnWriteReady;
//    SynchronizeMethod(FOnWriteReady);
IcsSocketDisplay(Name + ': WriterThread waiting for Event');
    WaitEvent;
IcsSocketDisplay(Name + ': WriterThread Event set');

    // Then loop until we can send something and we have something to wend
    FD_ZERO(WriteFds);
    while not Terminated do begin
        FD_SET(HSocket, WriteFds);
IcsSocketDisplay(Name + ': WriterThread waiting in select');
        Count := select(HSocket + 1, nil, @writeFds, nil , nil);
IcsSocketDisplay(Name + ': WriterThread select done');
        if Count < 0 then begin
            FLastError := WSAGetLastError;
            break;
        end;
        if Count = 0 then
            continue;
        if FD_ISSET(HSocket, WriteFds) then begin
            if Assigned(FOnWriteReady) then
                FOnWriteReady;
            //SynchronizeMethod(FOnWriteReady);
            // Event is set by Send procedure
IcsSocketDisplay(Name + ': WriterThread waiting for Event');
            WaitEvent;
IcsSocketDisplay(Name + ': WriterThread Event set');
        end;
    end;
    IcsSocketDisplay(Name + ': WriterThread.Execute finished');
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
constructor TIcsThread.Create(CreateSuspended : Boolean);
begin
    inherited Create(TRUE);
    FinishedFlag := FALSE;
    FSyncEvents  := TRUE;
    FEventObject := TEvent.Create(nil, FALSE, FALSE, ClassName);
    if not CreateSuspended then
        Resume;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
destructor TIcsThread.Destroy;
begin
    if Assigned(FEventObject) then begin
        FEventObject.Destroy;
        FEventObject := nil;
    end;
    inherited Destroy;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TIcsThread.DoTerminate;
begin
    IcsSocketDisplay(Name + ': DoTerminate');
    FinishedFlag := TRUE;     // Hack for Kylix WaitFor bug
    if ClosedByRemote then begin
        ChangeState(wsClosed);
//      FLastError := WSAECONNRESET;
        SynchronizeMethod(FOnClose);
    end;
    inherited DoTerminate;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TIcsThread.SynchronizeMethod(Proc : TIcsProcOfObject);
begin
    if Assigned(Proc) then begin
        if FSyncEvents then
            Synchronize(Proc)
        else
            Proc;
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TIcsThread.ChangeState(NewState: TIcsSocketState);
begin
   if FState = NewState then
       Exit;
   FOldState := FState;
   FState    := NewState;
   if not (csDestroying in ComponentState) then
       SynchronizeMethod(TriggerChangeState);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TIcsThread.TriggerChangeState;
begin
    if Assigned(FOnChangeState) then
        FOnChangeState;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TIcsThread.SetHSocket(aSocket : TSocket);
begin
    if FHSocketLocation <> nil then
        FHSocketLocation^ := aSocket
    else
        raise Exception.Create('TIcsThread.HSocketLocation not set');
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  * * * * * * * *}
function TIcsThread.GetHSocket : TSocket;
begin
    if FHSocketLocation <> nil then
        Result := FHSocketLocation^
    else
        Result := INVALID_SOCKET;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  * * * * * * * *}
procedure TIcsThread.SetEvent;
begin
    FEventObject.SetEvent;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  * * * * * * * *}
procedure TIcsThread.WaitEvent;
begin
    FEventObject.WaitFor(LongWord($FFFFFFFF));
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  * * * * * * * *}
procedure TCustomSocksIcsSocket.SetSocksPort(sPort : String);
begin
    if State <> wsClosed then begin
        RaiseException('Can''t change socks port if not closed');
        Exit;
    end;
    FSocksPort := Trim(sPort);
    if Length(FSocksPort) = 0 then begin
        FSocksPortAssigned := FALSE;
        Exit;
    end;
    FSocksPortAssigned := TRUE;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  * * * * * * * *}
procedure TCustomSocksIcsSocket.SetSocksServer(sServer : String);
begin
    if State <> wsClosed then begin
        RaiseException('Can''t change socks server if not closed');
        Exit;
    end;
    FSocksServer := Trim(sServer);
    if Length(FSocksServer) = 0 then begin
        FSocksServerAssigned := FALSE;
        Exit;
    end;
    FSocksServerAssigned := TRUE;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  * * * * * * * *}
procedure TCustomSocksIcsSocket.SetSocksLevel(newValue : String);
begin
    if State <> wsClosed then begin
        RaiseException('Can''t change socks level if not closed');
        Exit;
    end;
    if (newValue <> '4')  and (newValue <> '5') and
       (newValue <> '4A') and (newValue <> '4a') then begin
        RaiseException('Invalid socks level. Must be 4, 4A or 5.');
        Exit;
    end;
    FSocksLevel := UpperCase(newValue);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  * * * * * * * *}
procedure TCustomSocksIcsSocket.AssignDefaultValue;
begin
    inherited AssignDefaultValue;
    FSocksServer         := '';
    FSocksPort           := '';
    FSocksLevel          := '5';
    FSocksRcvdCnt        := 0;
    FSocksPortAssigned   := FALSE;
    FSocksServerAssigned := FALSE;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomSocksIcsSocket.Connect;
begin
    { Check if we really wants to use socks server }
    if not FSocksServerAssigned then begin
        { No socks server assigned, connect as usual }
        inherited Connect;
        Exit;
    end;

    if LowerCase(FProtoStr) <> 'tcp' then begin
        RaiseException('tcp is the only protocol supported thru socks server');
        Exit;
    end;

    FRcvCnt     := 0;

    { Create worker thread if needed, check if busy if already exists }
    if not GetWorkerThread then begin
        RaiseException('SocksConnect: Component is busy.');
        TriggerSessionConnected(WSAEINPROGRESS);
        Exit;
    end;

    { Remove any data from the internal output buffer }
    { (should already be empty !)                     }
    DeleteBufferedData;

    FWorkerThread.ChangeState(wsConnecting);
    FWorkerThread.HSocketLocation     := @FHSocket;
    FWorkerThread.Operation           := iwtSocksConnect;
    FWorkerThread.SocksServer         := FSocksServer;
    FWorkerThread.SocksPort           := FSocksPort;
    FWorkerThread.SocksUsercode       := FSocksUserCode;
    FWorkerThread.SocksPassword       := FSocksPassword;
    FWorkerThread.SocksLevel          := FSocksLevel;
    FWorkerThread.SocksAuthentication := FSocksAuthentication;
    FWorkerThread.ProtoStr            := FProtoStr;
    FWorkerThread.PortStr             := FPortStr;
    FWorkerThread.LocalPortStr        := FLocalPortStr;
    FWorkerThread.LocalAddr           := FLocalAddr;
    FWorkerThread.AddrStr             := FAddrStr;
    FWorkerThread.LingerOnOff         := FLingerOnOff;
    FWorkerThread.LingerTimeout       := FLingerTimeout;
    FWorkerThread.OnOperationDone     := OperationDoneConnect;
    FWorkerThread.OnDoReadReady       := DoReadReady;
    FWorkerThread.OnClose             := SocketHasClosed;
    FWorkerThread.OnChangeState       := ChangeState;
    FWorkerThread.Resume;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TIcsWorkerThread.SocksSessionConnected;
var
    Buf     : array [0..2] of char;
    RcvBuf  : array [0..1] of char;
    iStatus : Integer;
begin
    SynchronizeMethod(FOnSocksConnected);
    if FLastError <> 0 then begin
//            OperationDoneConnect;
        Exit;
    end;
    if FSocksLevel[1] = '4' then
//        SocksDoConnect
    else begin
        if FSocksAuthentication = icsSocksNoAuthentication then
            FSocksAuthNumber := #$00   { No authentification }
        else
            FSocksAuthNumber := #$02;  { Usercode/Password   }

        Buf[0] := #$05;                { Version number      }
        Buf[1] := #$01;                { Number of methods   }
        Buf[2] := FSocksAuthNumber;    { Method identifier   }
{TriggerDisplay('Send = ''' + BufToStr(Buf, 3) + '''');}
        iStatus := Ics_send(HSocket, Buf[0], 3, 0);
        if iStatus <> 3 then begin
            TriggerSocksError(icsSocksProtocolError,
                              'Unable to send socks command');
            Exit;
        end;
        iStatus := Ics_recv(HSocket, RcvBuf, 2, 0);
        if iStatus <> 2 then begin
            // Error, we must receive two bytes
            TriggerSocksError(icsSocksProtocolError, 'Invalid socks answer');
            Exit;
        end;
        if RcvBuf[0] <> #$05 then begin
            TriggerSocksError(icsSocksVersionError, 'socks version error');
            Exit;
        end;
        if RcvBuf[1] = #$00 then begin
            { No authentication required }
            if FSocksAuthNumber <> #$00 then begin
                { We asked for authentification, so complains... }
                FSocksAuthState := icsSocksAuthNotRequired;
                SynchronizeMethod(FOnSocksAuthState);
            end;
        end
        else if RcvBuf[1] = #$02 then begin
            { Usercode/Password authentication required }
            SocksDoAuthenticate;
            Exit;
        end
        else begin
            TriggerSocksError(icsSocksAuthMethodError, 'authentification method not acceptable');
            Exit;
        end;
//        SocksDoConnect;
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TIcsWorkerThread.SocksDoConnect;
type
    pu_long = ^u_long;
var
    Buf     : array [0..127] of char;
    I       : Integer;
//    ErrCode : Integer;
begin
    if FSocksLevel[1] = '4' then begin
        Buf[0] := #4;
        Buf[1] := #1;
        PWORD(@Buf[2])^  := Ics_ntohs(FPortNum);
        if FSocksLevel = '4A' then
            pu_long(@Buf[4])^ := Ics_inet_addr('0.0.0.1')
        else begin
            try
                pu_long(@Buf[4])^ := IcsSocketResolveHost(FAddrStr).s_addr;
            except
                on E:Exception do begin
//                     ErrCode := icsSocksHostResolutionFailed;
//                     TriggerSocksError(ErrCode, E.ClassName + ' ' + E.Message);
//                     InternalClose(TRUE, ErrCode);
                    Ics_closesocket(HSocket);
                    HSocket := INVALID_SOCKET;
                    FLastError := icsSocksHostResolutionFailed;
                    Exit;
                end;
            end;
        end;
        I := 8;
        if Length(FSocksUsercode) > 0 then begin
            { I'm not sure it has to be like that ! Should I also use the }
            { password or not ?                                           }
            Move(FSocksUsercode[1], Buf[I], Length(FSocksUsercode));
            I := I + Length(FSocksUsercode);
        end;
        Buf[I] := #0;
        Inc(I);
        if FSocksLevel = '4A' then begin
            Move(FAddrStr[1], Buf[I], Length(FAddrStr));
            I := I + Length(FAddrStr);
            Buf[I] := #0;  { Alon Gingold }
            Inc(I);        { Alon Gingold }
        end;
        { Buf[I] := #0;      Alon Gingold }
        { Inc(I);            Alon Gingold }
    end
    else begin
        Buf[0] := #$05;            { Socks version }
        Buf[1] := #$01;            { Connect command }
        Buf[2] := #$00;            { Reserved, must be $00 }
        Buf[3] := #$03;            { Address type is domain name }
        Buf[4] := chr(Length(FAddrStr));
        { Should check buffer overflow }
        Move(FAddrStr[1], Buf[5], Length(FAddrStr));
        I := 5 + Length(FAddrStr);
        PWord(@Buf[I])^ := Ics_htons(FPortNum);
        I := I + 2;
    end;

    try
{TriggerDisplay('Send = ''' + BufToStr(Buf, I + 2) + '''');}
        Ics_send(HSocket, Buf[0], I, 0);
        SocksConnectedToRemote;
    except
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TIcsWorkerThread.SocksConnectedToRemote;
var
    Len     : Integer;
    RcvBuf  : array [0..15] of char;
    ErrCode : Integer;
    ErrMsg  : String;
    InAddr  : TInAddr;
    InPort  : WORD;
begin
    if FSocksLevel[1] = '4' then begin
        { We wants 8 characters }
        Len := Ics_recv(HSocket, RcvBuf[0], 8, 0);
        { We are waiting for 8 bytes }
        if Len <> 8 then
            Exit;
        if RcvBuf[0] <> #0 then begin
            TriggerSocksError(icsSocksVersionError, 'socks version error');
            Exit;
        end;
        if RcvBuf[1] = #$90 then begin
            case RcvBuf[1] of
            #$91: ErrCode := icsSocksRejectedOrFailed;
            #$92: ErrCode := icsSocksConnectionRefused;
            #$93: ErrCode := icsSocksAuthenticationFailed;
            else
               ErrCode := icsSocksUnassignedError;
            end;
            case ErrCode of
            icsSocksRejectedOrFailed :
                ErrMsg := 'request rejected or failed';
            icsSocksConnectionRefused :
                ErrMsg := 'connection refused';
            icsSocksAuthenticationFailed :
                ErrMsg := 'authentification failed';
            else
                ErrMsg := 'unassigned error #' + IntToStr(Ord(RcvBuf[1]));
            end;
            TriggerSocksError(ErrCode, ErrMsg);
            Exit;
        end;
    end
    else begin { SOCKS5 }
        { Receive version number }
        Len := Ics_recv(HSocket, RcvBuf[0], 1, 0);
        if Len < 1 then
            Exit;
        { First byte is version, we expect version 5 }
        if RcvBuf[0] <> #$05 then begin
            TriggerSocksError(icsSocksVersionError, 'socks version error');
            Exit;
        end;
        // Receive error code
        Len := Ics_recv(HSocket, RcvBuf[0], 1, 0);
        if Len < 1 then
            Exit;
        if RcvBuf[0] <> #$00 then begin
            case RcvBuf[0] of
            #1: ErrCode := icsSocksGeneralFailure;
            #2: ErrCode := icsSocksConnectionNotAllowed;
            #3: ErrCode := icsSocksNetworkUnreachable;
            #4: ErrCode := icsSocksHostUnreachable;
            #5: ErrCode := icsSocksConnectionRefused;
            #6: ErrCode := icsSocksTtlExpired;
            #7: ErrCode := icsSocksUnknownCommand;
            #8: ErrCode := icsSocksUnknownAddressType;
            else
               ErrCode := icsSocksUnassignedError;
            end;
            case ErrCode of
            icsSocksGeneralFailure :
                ErrMsg := 'general SOCKS server failure';
            icsSocksConnectionNotAllowed :
                ErrMsg := 'connection not allowed by ruleset';
            icsSocksNetworkUnreachable :
                ErrMsg := 'network unreachable';
            icsSocksHostUnreachable :
                ErrMsg := 'host unreachable';
            icsSocksConnectionRefused :
                ErrMsg := 'connection refused';
            icsSocksTtlExpired :
                ErrMsg := 'time to live expired';
            icsSocksUnknownCommand :
                ErrMsg := 'command not supported';
            icsSocksUnknownAddressType :
                ErrMsg := 'address type not supported';
            else
                ErrMsg := 'unassigned error #' + IntToStr(Ord(RcvBuf[0]));
            end;
            TriggerSocksError(ErrCode, ErrMsg);
            Exit;
        end;
        // Receive answer type
        Len := Ics_recv(HSocket, RcvBuf[0], 2, 0);
        if Len <> 2 then
            Exit;
        if RcvBuf[1] = #$01 then begin
            // IP V4 address
            Len := Ics_recv(HSocket, InAddr, 4, 0);
            if Len <> 4 then
                Exit;
            FSocksBoundAddr := StrPas(Ics_inet_ntoa(InAddr));
        end
        else if RcvBuf[1] = #$03 then begin
            // Domain name, get length
            Len := Ics_recv(HSocket, RcvBuf[0], 1, 0);
            if Len <> 1 then
                Exit;
            SetLength(FSocksBoundAddr, Ord(RcvBuf[0]));
            Len := Ics_recv(HSocket, FSocksBoundAddr[1], Length(FSocksBoundAddr), 0);
            if Len <> Length(FSocksBoundAddr) then
                Exit;
        end
        else begin
            // Unsupported address type
            TriggerSocksError(icsSocksUnknownAddressType, 'address type not supported');
            Exit;
        end;

        // Receive port
        Len := Ics_recv(HSocket, InPort, 2, 0);
        if Len <> 2 then
            Exit;
        FSocksBoundPort  := format('%d', [Ics_ntohs(InPort)]);
//          inherited TriggerSessionConnected(0);
//        {inherited} TriggerSessionConnected(0);
        {**ALON** removed 'inherited' now calls top level}
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TIcsWorkerThread.SocksDoAuthenticate;
var
    Buf     : array [0..127] of char;
    I       : Integer;
begin
    FSocksAuthState := icsSocksAuthStart;
    SynchronizeMethod(FOnSocksAuthState);
    Buf[0] := #$01; {06/03/99}           { Socks version }
    I      := 1;
    Buf[I] := chr(Length(FSocksUsercode));
    Move(FSocksUsercode[1], Buf[I + 1], Length(FSocksUsercode));
    I := I + 1 + Length(FSocksUsercode);
    Buf[I] := chr(Length(FSocksPassword));
    Move(FSocksPassword[1], Buf[I + 1], Length(FSocksPassword));
    I := I + 1 + Length(FSocksPassword);
    try
{TriggerDisplay('Send = ''' + BufToStr(Buf, I) + '''');}
        Ics_send(HSocket, Buf[0], I, 0);
        SocksAuthenticateReply;
    except
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TIcsWorkerThread.SocksAuthenticateReply;
var
    Len    : Integer;
    RcvBuf : array [0..20] of char;
begin
    // First byte is version, we expect version 5
    Len := Ics_recv(HSocket, RcvBuf[0], 1, 0);
    if Len <> 1 then begin
        TriggerSocksError(icsSocksDataReceiveError, 'unable to receive reply');
        Exit;
    end;

    if RcvBuf[0] <> #$01 then begin { 06/03/99 }
{       TriggerSocksAuthState(socksAuthFailure); Burlakov 12/11/99 }
        TriggerSocksError(icsSocksVersionError, 'socks version error');
        Exit;
    end;

    // Second byte is status
    Len := Ics_recv(HSocket, RcvBuf[0], 1, 0);
    if Len <> 1 then begin
        TriggerSocksError(icsSocksDataReceiveError, 'unable to receive reply');
        Exit;
    end;

    if RcvBuf[0] <> #$00 then begin
{       TriggerSocksAuthState(socksAuthFailure); Burlakov 12/11/99 }
        TriggerSocksError(icsSocksAuthenticationFailed, 'socks authentication failed');
        Exit;
    end;

//    TriggerSocksAuthState(icsSocksAuthSuccess);
//    SocksDoConnect;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TIcsWorkerThread.TriggerSocksError(
    ErrCode : Integer;
    Msg     : String);
begin
    FSocksError    := ErrCode;
    FSocksErrorMsg := Msg;
    SynchronizeMethod(FOnSocksError);
    FLastError := ErrCode;
    Ics_closesocket(HSocket);
    HSocket := INVALID_SOCKET;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomSocksIcsSocket.TriggerSocksConnected(Error : Word);
begin
    if Assigned(FOnSocksConnected) then
        FOnSocksConnected(Self, Error);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomSocksIcsSocket.TriggerSocksError(Error : Integer; Msg : String);
begin
    if Assigned(FOnSocksError) then
        FOnSocksError(Self, Error, Msg);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomSocksIcsSocket.TriggerSocksAuthState(AuthState : TIcsSocksAuthState);
begin
    if Assigned(FOnSocksAuthState) then
        FOnSocksAuthState(Self, AuthState);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
procedure TCustomLineIcsSocket.SetLineMode(newValue : Boolean);
begin
    if FLineMode = newValue then
        Exit;
    FLineMode := newValue;
//    if (FRcvdCnt > 0) or (FLineLength > 0) then
//        PostMessage(Handle, WM_TRIGGER_DATA_AVAILABLE, 0, 0);
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
constructor TCustomLineIcsSocket.Create(AOwner: TComponent);
begin
    inherited Create(AOwner);
    FLineEnd  := #13#10;
    FLineMode := FALSE;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
destructor TCustomLineIcsSocket.Destroy;
begin
    if FRcvdPtr <> nil then begin
        FreeMem(FRcvdPtr, FRcvBufSize);
        FRcvdPtr     := nil;
        FRcvBufSize := 0;
    end;
    inherited Destroy;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function TCustomLineIcsSocket.GetRcvdCount : LongInt;
begin
    if not FLineMode then
        Result := FRcvdCnt + inherited GetRcvdCount
    else
        Result := FLineLength;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
function TCustomLineIcsSocket.DoRecv(
    var Buffer;
    BufferSize : Integer;
    Flags      : Integer) : Integer;
begin
    if FLineMode and (FLineLength > 0) then begin
        { We are in line mode an a line is received }
        if FLineLength <= BufferSize then begin
            { User buffer is greater than received data, copy all and clear }
            Move(FRcvdPtr^, Buffer, FLineLength);
            Result      := FLineLength;
            FLineLength := 0;
            Exit;
        end;
        { User buffer is smaller, copy as much as possible }
        Move(FRcvdPtr^, Buffer, BufferSize);
        Result   := BufferSize;
        { Move the end of line to beginning of buffer to be read the next time }
        Move(FRcvdPtr[BufferSize], FRcvdPtr^, FLineLength - BufferSize);
        FLineLength := FLineLength - BufferSize;
        Exit;
    end;

    if (FLineMode) or (FRcvdCnt <= 0) then begin
        { There is nothing in our internal buffer }
        Result := inherited DoRecv(Buffer, BufferSize, Flags);
        Exit;
    end;

    { We already have received data into our internal buffer }
    if FRcvdCnt <= BufferSize then begin
        { User buffer is greater than received data, copy all and clear }
        Move(FRcvdPtr^, Buffer, FRcvdCnt);
        Result   := FRcvdCnt;
        FRcvdCnt := 0;
        Exit;
    end;
    { User buffer is smaller, copy as much as possible }
    Move(FRcvdPtr^, Buffer, BufferSize);
    Result   := BufferSize;
    { Then move remaining data to front og buffer  16/10/99 }
    Move(FRcvdPtr[BufferSize], FRcvdPtr^, FRcvdCnt - BufferSize + 1);
    FRcvdCnt := FRcvdCnt - BufferSize;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
{ Edit received data. Handle TAB and BACKSPACE characters.                  }
{ A data packet has been received into FRcvPtr buffer, starting from        }
{ FRcvdCnt offset. Packet size if passed as the Len argument.               }
procedure TCustomLineIcsSocket.EditLine(var Len : Integer);
var
    Buf     : PChar;
    BufSize : Integer;
    I       : Integer;
    J       : Integer;
    Edited  : Boolean;
    NewCnt  : Integer;
    NewSize : Integer;
const
    BackString : String = #8 + ' ' + #8;
begin
    BufSize := 0;
    try
        Edited := FALSE;
        I      := FRcvdCnt;
        J      := FRcvdCnt;
        NewCnt := FRcvdCnt;
        { Loop to process all received char }
        while I < (FRcvdCnt + Len) do begin
            if FRcvdPtr[I] = #8 then begin   { BACKSPACE character }
                if FLineEcho and (J > 0) then
                    SendStr(BackString);
                if not Edited then begin
                    { Not edited yet, so we allocate a buffer to store }
                    { edited data and we remember we edited data.      }
                    Edited := TRUE;
                    { Computer buffer size as a multiple of 256 bytes  }
                    BufSize := ((FRcvdCnt + Len + 256) shr 8) shl 8;
                    GetMem(Buf, BufSize);
                    { Copy data already processed }
                    Move(FRcvdPtr^, Buf^, I);
                end;
                if J > 0 then begin
                    Dec(J);
                    if J < NewCnt then
                        NewCnt := J;
                end;
                Inc(I);
            end
            else if FRcvdPtr[I] = #9 then begin  { TAB character }
                if not Edited then begin
                    { Not edited yet, so we allocate a buffer to store }
                    { edited data and we remember we edited data.      }
                    Edited := TRUE;
                    { Computer buffer size as a multiple of 256 bytes  }
                    BufSize := ((FRcvdCnt + Len + 256) shr 8) shl 8;
                    GetMem(Buf, BufSize);
                    { Copy data already processed }
                    Move(FRcvdPtr^, Buf^, I);
                end;
                repeat
                    if FLineEcho then
                        SendStr(' ');
                    Buf[J] := ' ';
                    Inc(J);
                until (J and 7) = 0;
                Inc(I);
            end
            else begin
                if FLineEcho then
                    Send(@FRcvdPtr[I], 1);
                if Edited then begin
                    if J >= BufSize then begin
                        { Need to allocate more buffer space }
                        NewSize := BufSize + 256;
                        ReallocMem(Buf, NewSize);
                        BufSize := NewSize;
                    end;
                    Buf[J] := FRcvdPtr[I];
                end;
                Inc(I);
                Inc(J);
            end;
        end;
        if Edited then begin
            if J >= FRcvBufSize then begin
                { Current buffer is too small, allocate larger }
                NewSize := J + 1;
                ReallocMem(FRcvdPtr, NewSize);
                FRcvBufSize := NewSize;
            end;
            { Move edited data back to original buffer }
            Move(Buf^, FRcvdPtr^, J);
            FRcvdPtr[J] := #0;
            FRcvdCnt := NewCnt;
            Len      := J - FRcvdCnt;
        end;
    finally
        if BufSize > 0 then
            FreeMem(Buf, BufSize);
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
// This function is called from within workerthread context
procedure TCustomLineIcsSocket.DoReadReady;
var
    Cnt        : Integer;
    Len        : Integer;
    NewSize    : Integer;
    SearchFrom : Integer;
    I          : Integer;
    Found      : Boolean;
    FlagOff    : Boolean;
begin
    if (not FLineMode) or (Length(FLineEnd) = 0) then begin
        { We are not in line mode }
        inherited DoReadReady;
        Exit;
    end;

    { We are in line mode. We receive data ourself }
    Cnt := inherited GetRcvdCount;
    if Cnt < 0 then
        Exit;
    if (FRcvdCnt + Cnt + 1) > FRcvBufSize then begin
        { Current buffer is too small, allocate larger }
        NewSize := FRcvdCnt + Cnt + 1;
        ReallocMem(FRcvdPtr, NewSize);
        FRcvBufSize := NewSize;
    end;

    Len := Receive(FRcvdPtr + FRcvdCnt, Cnt);
    if Len < 0 then                       // Should never occurs
        Exit;
    if Len = 0 then begin
        // Closed by remote
        if FRcvdCnt > 0 then begin
            // Deliver remaining data
            FLineLength := FRcvdCnt;      // Consider as a full line
            while FLineLength > 0 do      // Potential infinite loop !
                inherited DoReadReady;
        end;
        FWorkerThread.ClosedByRemote := TRUE;
        Exit;
    end;
    FRcvdPtr[FRcvdCnt + Len] := #0;
    if FLineEdit then
        EditLine(Len)
    else if FLineEcho then
        Send(FRcvdPtr + FRcvdCnt, Len);
    SearchFrom := FRcvdCnt - Length(FLineEnd);
    if SearchFrom < 0 then
        SearchFrom := 0;
    FRcvdCnt := FRcvdCnt + Len;
    while FLineMode do begin
        Found := FALSE;
        I := SearchFrom;
        while I < (FRcvdCnt - Length(FLineEnd) + 1) do begin
            if FRcvdPtr[I] = FLineEnd[1] then begin
                Found := (StrLComp(@FRcvdPtr[I], @FLineEnd[1], Length(FLineEnd)) = 0);
                if Found then
                    break;    { Found the end of line marker }
            end;
            Inc(I);
        end;
        if not Found then
            break;
        FLineLength       := I + Length(FLineEnd);
        FLineReceivedFlag := TRUE;
        { We received a complete line. We need to signal it to application }
        { The application may not have a large buffer so we may need       }
        { several events to read the entire line. In the meanwhile, the    }
        { application may turn line mode off.                              }
        FlagOff := FALSE;
        while FLineMode and (FLineLength > 0) do begin
            inherited DoReadReady;
            { Remember if line mode has been turned off }
            FlagOff := not FLineMode;
        end;
        { Move remaining data in front of buffer }
        if FLineLength > 0 then begin
            { Line mode was turned off in the middle of a line read. }
            { We preserve unread line and other received data.       }
            Move(FRcvdPtr[I], FRcvdPtr[FLineLength],
                 FRcvdCnt - I);
            FRcvdCnt := FRcvdCnt - I + FLineLength;
        end
        else begin
            Move(FRcvdPtr[I + Length(FLineEnd)], FRcvdPtr[0],
                 FRcvdCnt - I - Length(FLineEnd));
            FRcvdCnt := FRcvdCnt - I - Length(FLineEnd);
        end;
        FRcvdPtr[FRcvdCnt] := #0;
        SearchFrom         := 0;

        { If line mode was turning off during processing and there is }
        { still data, trigger event again                             }
        if FlagOff and (FRcvdCnt > 0) then
            inherited DoReadReady;
    end;
end;


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
{$IFNDEF WIN32}
const
  libcmodulename = 'libc.so.6';

function ioctlsocket;       external    libcmodulename name 'ioctl';
function getpeername;       external    libcmodulename name 'getpeername';
{$ENDIF}


{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}

end.
